from django.shortcuts import render ,redirect
from ajustementsstocks.models import AjustementStocks
from articles.models import Article
from detailsajustement.models import DetailAjustement
import decimal
from django.contrib import messages
from historiquearticles.models import HistoriqueArticle
import datetime
from core.decorators import allowed_users
from django.contrib.auth.decorators import login_required
# Create your views here.
@login_required(login_url="/login/")
def liste_ajustement_stock(request):
	context = {}
	context['segment'] = 'ajstock'
	context['ajustements'] = AjustementStocks.objects.all().order_by('created_at').reverse()

	return render(request, 'liste-ajustement.html', context)

@login_required(login_url="/login/")
def formulaire_ajuster_stockage(request):
	context = {}
	context['articles'] = Article.objects.all().order_by('created_at').reverse()
	return render(request, 'ajuster-stock.html', context)

@login_required(login_url="/login/")
def ajuster_stock(request):
	context = {}
	if request.method=="POST":
		date_d_ajustement = request.POST.get('date_d_ajustement')
		user = request.POST.get('user')
		article_options = request.POST.getlist('article_options[]')
		quantite_ajustee_options = request.POST.getlist('quantite_ajustee_options[]')
	ajustement = AjustementStocks(date_ajustement =date_d_ajustement,user = user  )
	ajustement.save()
	
	for i in range(len(article_options)):
		id_article = article_options[i].split()[0]
		quantitee_non_declarer_comme_lot = Article.objects.get(id=id_article).quantitee_non_declarer_comme_lot
		stock_comptable_disponible = Article.objects.get(id=id_article).stock_comptable_disponible
		Article.objects.filter(id =id_article).update(quantitee_non_declarer_comme_lot = quantitee_non_declarer_comme_lot + decimal.Decimal(quantite_ajustee_options[i])) 
		Article.objects.filter(id =id_article).update(stock_comptable_disponible= stock_comptable_disponible+ decimal.Decimal(quantite_ajustee_options[i]))
		
		article = Article.objects.get(id=id_article)
		details = 'quantitee ajustee  = +' ,quantite_ajustee_options[i],'par'
		historique = HistoriqueArticle(article =article, date =date_d_ajustement, user = user, details = details)
		historique.save()
		detailAjustement = DetailAjustement(ajustementStocks =ajustement,article = article  ,qantite = quantite_ajustee_options[i])
		detailAjustement.save()

	messages.success(request, 'Ajustement a été bien effectué')
	context['articles'] = Article.objects.all().order_by('created_at').reverse()
	return redirect('liste_ajustement_stock')


@login_required(login_url="/login/")
def supprimer_stock(request):
	context = {}
	if request.method=="POST":
		id_ajustement = request.POST.get('id_ajustement')

		ajustement = AjustementStocks.objects.get(id = id_ajustement)
		detailsAjustement = DetailAjustement.objects.filter(ajustementStocks = ajustement)

	
	for i in range(len(detailsAjustement)):

		id_article = detailsAjustement[i].article.id
		quantitee_non_declarer_comme_lot = Article.objects.get(id=id_article).quantitee_non_declarer_comme_lot
		stock_comptable_disponible = Article.objects.get(id=id_article).stock_comptable_disponible
		Article.objects.filter(id =id_article).update(quantitee_non_declarer_comme_lot = quantitee_non_declarer_comme_lot - detailsAjustement[i].qantite) 
		Article.objects.filter(id =id_article).update(stock_comptable_disponible= stock_comptable_disponible - detailsAjustement[i].qantite)
	ajustement.delete()
	messages.success(request, 'Ajustement a été bien effectué')
	context['articles'] = Article.objects.all().order_by('created_at').reverse()
	return redirect('liste_ajustement_stock')













