from django.shortcuts import render ,redirect
from clients.models import Client
from clients.forms import ClientForm , form_validation_error
from django.contrib import messages

from factures.models import Facture
from commandes.models import Commande
from paiements.models import Paiement
from django.contrib.auth.decorators import login_required
from django.db.models import Q
from articlescommandeefactures.models import Articlescommandeefactures
from colis.models import Colis
from django.contrib.auth.models import User
from django.contrib.auth.models import Group 
# Create your views here.
@login_required(login_url="/login/")
def liste_clients(request):
    context = {}
    context['segment'] = 'clients'
    context['liste_clients'] = Client.objects.all().order_by('updated_at').reverse()
    return render(request, 'liste-clients.html', context)

@login_required(login_url="/login/")
def affiche_ajouter_client(request):
	context = {}

	return render(request, 'ajouter-client.html', context)

@login_required(login_url="/login/")
def ajouter_client(request):
	if request.method == "POST":
		form = ClientForm(request.POST or None)
		if form.is_valid():
			print("is valid")
			form.save()
			messages.success(request, 'client a été bien ajouté')
		else:
			context = {}
			context['form']=form
			messages.error(request, form_validation_error(form))
			return render(request, 'ajouter-client.html', context)


	return redirect('liste_clients')

@login_required(login_url="/login/")
def afficher_client(request):
		context = {}
		context['segment'] = 'clients'
		if request.method == "POST":
			id_client = request.POST.get('client')
		else :
			id_client = request.GET.get('000')
		client = Client.objects.get(id = id_client)
		commandes = Commande.objects.filter(client = client).order_by('created_at').reverse()		
		last_commande = Commande.objects.filter(client = client).order_by('created_at').reverse().first()
		paiements = Paiement.objects.filter(commande__in = commandes).order_by('created_at').reverse()
		last_paiements = Paiement.objects.filter(commande__in = commandes).order_by('created_at').reverse().first()
		
		reste = 0 
		qnt_expediee = 0
		qnt_emballee = 0
		liste_paiement = []
		liste_colis = []
		for  c in commandes :
			if c.expiditions == 'expedie' :
				articlecommandee = ArticleCommandee.objects.filter(commande = c)
				for j in articlecommandee :
						qnt_expediee = j.expediee + qnt_expediee
			if c.emballage == 'emballee' :
				articlecommandee = ArticleCommandee.objects.filter(commande = c)
				for j in articlecommandee :
						qnt_emballee = j.qnt_emballee + qnt_emballee

			if Colis.objects.filter(commande = c).exists() :
				colis = Colis.objects.filter(commande = c)
				for coli in colis :
					liste_colis.append(coli)
			reste = reste + c.reste


		
		if 	len(liste_colis) >  0 :
			colis_last = liste_colis[len(liste_colis)-1]
			context['last_colis'] = colis_last	
		context['client'] = client
		context['commandes'] = commandes
		context['last_commande'] = last_commande	
		context['last_paiement'] = last_paiements
		context['paiements'] = paiements
		context['colis'] = liste_colis
		context['qnt_expediee'] = qnt_expediee
		context['qnt_emballee'] = qnt_emballee
		context['reste'] = reste	
		
		return render(request, 'afficher-client.html', context)

@login_required(login_url="/login/")
def affiche_modifier_client(request):
	context = {}

	if request.method == "POST":
		id_client = request.POST.get('client')
		client = Client.objects.get(id = id_client)
		context['client'] = client

		# context['liste_user'] = User.objects.all()
		# group = Group.objects.get(name='operatrices') 
		# context['group'] = group 


	return render(request, 'modifier-client.html', context)

@login_required(login_url="/login/")
def valider_modifier_client(request):
	if request.method == "POST":
			id_client = request.POST.get('client')
			client = Client.objects.get(id = id_client)
			nom = request.POST.get('nom')
			prenom = request.POST.get('prenom')
			telephone1 = request.POST.get('telephone1')
			telephone2 = request.POST.get('telephone2')
			adresse = request.POST.get('adresse')

			Client.objects.filter(id = id_client).update(nom = nom)
			Client.objects.filter(id = id_client).update(prenom = prenom)
			Client.objects.filter(id = id_client).update(telephone1 = telephone1)
			Client.objects.filter(id = id_client).update(telephone2 = telephone2)
			Client.objects.filter(id = id_client).update(adresse = adresse)

			# userajouter = request.POST.get('userajouter')
			# userz = User.objects.get(id=userajouter)
			# groupad = Group.objects.get(name='admingestion') 
			# groupass = Group.objects.get(name='assistante') 

			# if groupad in userz.groups.all() or groupass in userz.groups.all() :
			# 	useroperatrice = request.POST.get('userOp')
			# 	print('useroperatrice',useroperatrice)
			# 	if useroperatrice :
			# 		id_operatrice = useroperatrice.split()[0]
			# 		print('id_operatrice',id_operatrice)
			# 		operatrice = User.objects.get(id=id_operatrice)
			# 		print('operatrice',operatrice)
    
			# 		Client.objects.filter(id = id_client).update(user = operatrice)
			# else :
			# 	print('non entre')
			messages.success(request, 'client a été bien modifier')

	return redirect('liste_clients')


@login_required(login_url="/login/")
def supprimer_client(request):

	if request.method == "POST":
		id_client = request.POST.get('client')
		client = Client.objects.get(id = id_client)
		commandes = Commande.objects.filter(client = client)

		if commandes.exists() :
			messages.info(request, 'Ce contact ne peut pas être supprimé car il est associé à des transactions ou des documents')
		else :
			client.delete()
			messages.success(request, 'client a été bien supprimer')

	return redirect('liste_clients')
