from django.shortcuts import render ,redirect
from commandes.models import Commande
from clients.models import Client
from lots.models import Lot
from articles.models import Article
from articlescommandee.models import ArticleCommandee
from django.contrib import messages
from commandes.forms import CommandeForm ,form_validation_error
import decimal
from factures.models import Facture
from django.http import JsonResponse
from django.http import HttpResponse
from django.core.serializers import serialize
from django.core import serializers
from infosventes.models import InfoVente
from colis.models import Colis
from fournisseurs.models import Fournisseur
from avisderecu.models import Avisderecu
from django.contrib.auth.decorators import login_required
from detailsavisderecu.models import Detailsavisderecu
from retours.models import Retour
from facturesdavoir.views import  render_to_pdf
from django.views import View
from xhtml2pdf import pisa
from io import BytesIO
from django.http import HttpResponse
from django.template.loader import get_template
from datetime import date
from django.contrib.auth.models import User
from django.contrib.auth.models import Group 
from core.decorators import allowed_users
from paiements.models import Paiement
# Create your views here

class ViewPDFCommande(View):
	def get(self, request, *args, **kwargs):
		id_commande = request.GET.get('id_commande')
		type_commande = request.GET.get('type')

		commande = Commande.objects.get(id = id_commande)
		articlecommandee =  ArticleCommandee.objects.filter(commande=commande).order_by('created_at') 
		new_liste = []  
		list_n = []       
		for i in range(len(articlecommandee)):
			print('indice i ', i)
			if articlecommandee[i].article :
				art = articlecommandee[i].article.id
				if len(new_liste) > 0 : 
					print(len(new_liste))
					for j in range(len(new_liste)) :
						if new_liste[j].article :
							if art == new_liste[j].article.id  : 
								new_liste[j].qantite_total = new_liste[j].qantite_total + articlecommandee[i].qantite_total
								list_n.append(articlecommandee[i])		
				
				new_liste.append(articlecommandee[i])
			else :
				new_liste.append(articlecommandee[i])

		data = {
			"commande": Commande.objects.get(id = id_commande),
			"articlecommandee":  new_liste,
			"type" : type_commande
		}
		pdf = render_to_pdf('commande.html', data)
		return HttpResponse(pdf, content_type='application/pdf')

class DownloadPDFCommande(View):
	def get(self, request,*args,**kwargs):
		id_commande = request.GET.get('id_commande')
		commande = Commande.objects.get(id = id_commande)
		type_commande = request.GET.get('type')
		articlecommandee = ArticleCommandee.objects.filter(commande=commande).order_by('created_at') 
		new_liste = []  
		list_n = []       
		for i in range(len(articlecommandee)):
			print('indice i ', i)
			if articlecommandee[i].article :
				art = articlecommandee[i].article.id
				if len(new_liste) > 0 : 
					print(len(new_liste))
					for j in range(len(new_liste)) :
						if new_liste[j].article :
							if art == new_liste[j].article.id  : 
								new_liste[j].qantite_total = new_liste[j].qantite_total + articlecommandee[i].qantite_total
								list_n.append(articlecommandee[i])		
				
				new_liste.append(articlecommandee[i])
			else :
				new_liste.append(articlecommandee[i])
		data = {
			"commande": Commande.objects.get(id = id_commande),
			"articlecommandee": new_liste,
			"type" : type_commande
		}
		pdf = render_to_pdf('commande.html',data)
		#filename = "Invoice_%s.pdf" %("12341231")
		content = "attachment; filename= commande.pdf"
		response = HttpResponse(pdf,content_type = 'application/pdf')
		response['Content-Disposition'] = content
		return response

@login_required(login_url="/login/")
def liste_commandes(request):
    context = {}
    context['segment'] = 'commandes'
    # context['liste_commandes'] = Commande.objects.all().exclude(fournisseur__isnull = False)
    context['liste_commandes'] = Commande.objects.all().exclude(type_commande = 'bon_commande').order_by('updated_at').reverse()

    return render(request, 'liste-commandes.html', context)

@login_required(login_url="/login/")
def affiche_ajouter_commande(request):
	context = {}
	context['liste_clients'] = Client.objects.all()
	liste_articles = []
	artilces = Article.objects.all()
	for i in artilces :
		if Lot.objects.all().filter(article = i).exists():
			liste_articles.append(i)
			
	context['liste_articles'] = liste_articles

	return render(request, 'ajouter-commande.html', context)


@login_required(login_url="/login/")
def ajouter_commande(request):
	context = {}
	context['segment'] = 'commandes'
	context['liste_commandes'] = Commande.objects.all()
	if request.method == "POST":

		article = request.POST.getlist('article_options[]')
		lot = request.POST.getlist('lots_options[]')
		qantite = request.POST.getlist('qantite_options[]')
		taux = request.POST.getlist('taux_options[]')
		remise = request.POST.getlist('remise_options[]')
		taxe = request.POST.getlist('taxe_options[]')
		montant = request.POST.getlist('montant_options[]')
		description = request.POST.getlist('description_options[]')		

		if len(article) > 0  :
			if article[0] != '' :
				form = CommandeForm(request.POST or None)
				if form.is_valid():
					print("is valid")
					form.save()
					last_commande = Commande.objects.last().id
					commande = Commande.objects.get(id = last_commande)
					for i in range(len(qantite)):
						id_article = article[i].split()[0]
						articleobj = Article.objects.get(id=id_article)

						id_lot = lot[i].split()[0]
						lot_obj = Lot.objects.get(id=id_lot)
						articlecommandee = ArticleCommandee(commande = commande ,article = articleobj , lot = lot_obj,qantite_total=qantite[i] , taxe=taxe[i]  ,remise = remise[i] ,montant =montant[i]  , description = description[i] , taux = taux[i],reste_emballee = qantite[i] )
						articlecommandee.save()	

						# le cas de qantite de lot < qantite commande
						lot_quantite = lot_obj.quantitee
						if lot_quantite > 0 and decimal.Decimal(qantite[i] )> lot_quantite :
							new_stock = lot_obj.quantitee - lot_quantite
							while qt < decimal.Decimal(qantite[i]) : 
								dif_qt = decimal.Decimal(qantite[i]) - qt

								new_lot = Lot.objects.all().filter(article = articlecommandee.article).order_by('created_at').exclude(quantitee=0) 				
								second_lot = new_lot[1]
								if second_lot.quantitee >= dif_qt :
									qt = qt + dif_qt
									new_articlecommandee = ArticleCommandee(commande =articlecommandee.commande ,article = articlecommandee.article , lot = second_lot,qantite_total= dif_qt)
									new_articlecommandee.save()
										
								elif second_lot.quantitee < dif_qt :
									qt = qt + new_lot.quantitee  
									new_articlecommandee = ArticleCommandee(commande = articlecommandee.commande ,article = articlecommandee.article , lot = new_lot,qantite_total= new_lot.quantitee)
									new_articlecommandee.save()

							ArticleCommandee.objects.filter(id = articlecommandee[i].id).update(qantite_total = lot_quantite)			
						else :
							new_stock = lot_obj.quantitee - decimal.Decimal(qantite[i] )
						# na9so mn stock
						new_stock_comptable_disponible = articleobj.stock_comptable_disponible - decimal.Decimal(qantite[i])
						Article.objects.filter(id = articleobj.id).update(stock_comptable_disponible = new_stock_comptable_disponible)
						
						Lot.objects.filter(id = lot_obj.id).update(quantitee = new_stock)


					montant_payee = request.POST.get('paye')
					date_paiement = request.POST.get('date_paiement')
					montant_total = decimal.Decimal(montant_payee)
					if montant_total > 0 :
						paiement = Paiement(commande = commande , montant = montant_total , date = date_paiement)
						paiement.save()
						if montant_total == commande.total :
							Commande.objects.filter(id = last_commande).update(paiement = 'paye')
						else : 
							Commande.objects.filter(id = last_commande).update(paiement = 'partiellement payee')
					elif montant_total == 0  :
						Commande.objects.filter(id = last_commande).update(paiement = 'impaye')
					
					Commande.objects.filter(id = last_commande).update(reste = commande.total - montant_total)
					
					messages.success(request, 'commande a été bien ajouter')
				else :
					messages.error(request, form_validation_error(form))
			else :
				messages.error(request, 'Aucun article  selection')
				return redirect('affiche_ajouter_commande')
		else :
				messages.error(request, 'Aucun article  n’existe')
				return redirect('affiche_ajouter_commande')
	return redirect('liste_commandes')

@login_required(login_url="/login/")	
def afficher_commande(request):
	context = {}
	qteexpedie_qterenvoye_equal0 = True
	if request.method == "POST":
		id_commande = request.POST.get('id_commande')
		commande = Commande.objects.get(id = id_commande)
		articlecommandee = ArticleCommandee.objects.filter(commande=commande).order_by('created_at') 
		print(len(articlecommandee))
		new_liste = []  
		list_n = []       
		for i in range(len(articlecommandee)):
			print('indice i ', i)
			if articlecommandee[i].article :
				art = articlecommandee[i].article.id
				if len(new_liste) > 0 : 
					print(len(new_liste))
					for j in range(len(new_liste)) :
						if new_liste[j].article :
							if art == new_liste[j].article.id  : 
								new_liste[j].qantite_total = new_liste[j].qantite_total + articlecommandee[i].qantite_total
								list_n.append(articlecommandee[i])		
				
				new_liste.append(articlecommandee[i])
			else :
				new_liste.append(articlecommandee[i])

		context['articlecommandee'] = new_liste
		context['articlecommandeerep'] = list_n

		context['commande'] = commande
		if commande.client :
			client = Client.objects.get(id = commande.client.id)

		if Paiement.objects.filter(commande = commande).exists() :
			context['liste_paiement'] = Paiement.objects.filter(commande = commande)

		context['liste_colis'] = Colis.objects.filter(commande = commande)
		if commande.staut_retour:
			context['liste_retours'] = Retour.objects.filter(commande_id = id_commande)

		 

	return render(request, 'afficher-commande.html', context)



@login_required(login_url="/login/")
def checkNickName(request):
    # request should be ajax and method should be GET.
    if request.is_ajax and request.method == "GET":
        # get the nick name from the client side.
        nick_name = request.GET.get("nick_name", None)

        #  qs = Entrepot.objects.filter(nom = nick_name)
        article = Article.objects.filter(id = nick_name)
        article1 = Article.objects.get(id = nick_name)

        lot = Lot.objects.filter(article = article1).order_by('date_arrivage').exclude(quantitee=0)
        data = serialize("json", lot)
        print('afficher entre')
        # check for the nick name in the database.
        if Lot.objects.all().filter(article = article1).exists():
        	if Lot.objects.all().filter(article = article1).order_by('date_arrivage').exclude(quantitee=0).exists():
	            # if nick_name found return not valid new friend
	            return JsonResponse({"data":data}, status = 200)
	        else :
	        	lot = Lot.objects.all().filter(article = article1).order_by('date_arrivage')
	        	data = serialize("json", lot)
	        	return JsonResponse({"data":data}, status = 200)
        else:
            # if nick_name not found, then user can create a new friend.
            return JsonResponse({"valid":True}, status = 200)
    else :
    	print('non entre')
    return JsonResponse({}, status = 400)

@login_required(login_url="/login/")
def checkInfoVente(request):
    # request should be ajax and method should be GET.
    if request.is_ajax and request.method == "GET":
        # get the nick name from the client side.
        info_vente = request.GET.get("info_vente", None)

        #  qs = Entrepot.objects.filter(nom = nick_name)
        infovente = InfoVente.objects.filter(id = info_vente)
        #infovente1 = InfoVente.objects.get(id = info_vente)
        # lot = Lot.objects.all().filter(article = article1).order_by('created_at')
        data = serialize("json", infovente)
        # check for the nick name in the database.
        if InfoVente.objects.filter(id = info_vente).exists():
            # if nick_name found return not valid new friend
            return JsonResponse({"data":data}, status = 200)
        else:
            # if nick_name not found, then user can create a new friend.
            return JsonResponse({"valid":True}, status = 200)

    return JsonResponse({}, status = 400)    

@login_required(login_url="/login/")
@allowed_users(allowed_roles=['admingestion','assistante'])
def affiche_ajouter_bon_commande(request):
	context = {}
	context['liste_fournisseurs'] = Fournisseur.objects.filter(status = 'actif')

	# liste_articles = []
	artilces = Article.objects.all()
	# for i in artilces :
	# 	if Lot.objects.filter(article = i).exists():
	# 		liste_articles.append(i)
	context['liste_articles'] = artilces
	return render(request, 'ajouter-bon-commande.html', context)


@login_required(login_url="/login/")
@allowed_users(allowed_roles=['admingestion','assistante'])
def liste_bon_commandes(request):
    context = {}
    context['segment'] = 'boncommandes'
    # context['liste_bon_commandes'] = Commande.objects.all().exclude(fournisseur = None)
    context['liste_bon_commandes'] = Commande.objects.all().exclude(type_commande = 'commande')
    return render(request, 'liste-bons-commandes.html', context)

@login_required(login_url="/login/")
@allowed_users(allowed_roles=['admingestion','assistante'])
def ajouter_bn_commande(request):
	context = {}
	context['segment'] = 'commandes'
	context['liste_commandes'] = Commande.objects.all()
	if request.method == "POST":

		article = request.POST.getlist('article_options[]')
		qantite = request.POST.getlist('qantite_options[]')
		taux = request.POST.getlist('taux_options[]')
		remise = request.POST.get('remise')
		taxe = request.POST.getlist('taxe_options[]')
		montant = request.POST.getlist('montant_options[]')
		description = request.POST.getlist('description_options[]')		
		form = CommandeForm(request.POST or None)
		if form.is_valid():
			print("is valid")
			form.save()
			last_commande = Commande.objects.last().id
			commande = Commande.objects.get(id = last_commande)
			for i in range(len(qantite)):
				id_article = article[i].split()[0]
				articleobj = Article.objects.get(id=id_article)
				articlecommandee = ArticleCommandee(commande = commande ,article = articleobj ,qantite_total=qantite[i] , taxe=taxe[i],montant =montant[i] , description = description[i] , taux = taux[i],reste_emballee = qantite[i])
				articlecommandee.save()	

				new_stock_comptable_disponible = articleobj.stock_comptable_disponible + decimal.Decimal(qantite[i])
				new_quantitee_non_declarer_comme_lot = articleobj.quantitee_non_declarer_comme_lot + decimal.Decimal(qantite[i])
				Article.objects.filter(id = id_article).update(stock_comptable_disponible = new_stock_comptable_disponible)
				Article.objects.filter(id = id_article).update(quantitee_non_declarer_comme_lot = new_quantitee_non_declarer_comme_lot)

			montant_payee = request.POST.get('paye')
			date_paiement = request.POST.get('date_paiement')

			montant_total = decimal.Decimal(montant_payee)
			if montant_total > 0 :
				paiement = Paiement(commande = commande , montant = montant_total , date = date_paiement)
				paiement.save()
				if montant_total == commande.total :
					Commande.objects.filter(id = last_commande).update(paiement = 'paye')
				else : 
					Commande.objects.filter(id = last_commande).update(paiement = 'partiellement payee')
			elif montant_total == 0  :
				Commande.objects.filter(id = last_commande).update(paiement = 'impaye')

			Commande.objects.filter(id = last_commande).update(reste = commande.total - montant_total)
			messages.success(request, 'bon de commande a été bien ajouter')
		else :		
			messages.error(request, form_validation_error(form))
			print(form_validation_error(form))	
			
	return redirect('liste_bon_commandes')

@login_required(login_url="/login/")
@allowed_users(allowed_roles=['admingestion','assistante'])	
def afficher_bon_commande(request):
	context = {}
	if request.method == "POST":
		id_commande = request.POST.get('id_commande')
		commande = Commande.objects.get(id = id_commande)
		articlecommandee = ArticleCommandee.objects.all().filter(commande=commande).order_by('created_at') 

		context['articlecommandee'] = articlecommandee
		context['commande'] = commande
		if commande.fournisseur :
			fournisseur = Fournisseur.objects.get(id = commande.fournisseur.id)
		# address_fact = Address.objects.filter(fournisseur = fournisseur).filter(type_Ad = 'facturation').order_by('created_at').reverse()
		# address_livr = Address.objects.filter(fournisseur = fournisseur).filter(type_Ad = 'livraison').order_by('created_at').reverse()
		# context['address_fact'] = address_fact
		# context['address_livr'] = address_livr

		facture = Facture.objects.filter(commande = commande)
		if facture :
			context['liste_facture'] = facture
		avisdereception = Avisderecu.objects.filter(commande = commande)
		if avisdereception :
			context['liste_avisdereception'] = avisdereception
		# if commande.status == 'BROUILLON':
		# 	numc = Commande.objects.all().exclude(id = id_commande).exclude(num_commande = 0).order_by('created_at').reverse().first()
		# 	if numc  :
		# 		context['num_commande'] = '00'+ str(int(numc.num_commande) + 1)
		# 	else :
		# 		context['num_commande']  = '001'
		if Paiement.objects.filter(commande = commande).exists() :
			context['liste_paiement'] = Paiement.objects.filter(commande = commande)

	return render(request, 'afficher-bon-commande.html', context)	


@login_required(login_url="/login/")
@allowed_users(allowed_roles=['admingestion','assistante'])
def confirme_bon_commande(request):
	context = {}
	if request.method == "POST":
		id_commande = request.POST.get('id_commande')
		num_commande = request.POST.get('num_commande')

		commande1 = Commande.objects.get(id = id_commande)
		articlecommandee = ArticleCommandee.objects.filter(commande=commande1).order_by('created_at') 
		if commande1.status == 'BROUILLON' :
			Commande.objects.filter(id = id_commande).update(status = "Emise")
			Commande.objects.filter(id = id_commande).update(num_commande = num_commande)
	
			messages.success(request, 'Le statut du bon de commande a été remplacé par « Émise ».')			
		
		commande = Commande.objects.get(id = id_commande)	
		address_fact = Address.objects.filter(fournisseur = commande.fournisseur).filter(type_Ad = 'facturation').order_by('created_at').reverse()
		address_livr = Address.objects.filter(fournisseur = commande.fournisseur).filter(type_Ad = 'livraison').order_by('created_at').reverse()

		context['articlecommandee'] = articlecommandee
		context['commande'] = commande
		context['address_fact'] = address_fact
		context['address_livr'] = address_livr

	return render(request, 'afficher-bon-commande.html', context)	

@login_required(login_url="/login/")
@allowed_users(allowed_roles=['admingestion','assistante'])
def convertir_en_facture_fournisseur(request):
	context = {}
	if request.method == "POST":
		id_commande = request.POST.get('id_commande')
		commande = Commande.objects.get(id = id_commande)
		articlecommandee = ArticleCommandee.objects.filter(commande=commande)
		
		sous_total = 0
		total = 0
		if articlecommandee :   
			for i in range(len(articlecommandee)):
					sous_total  =articlecommandee[i].montant_reste + sous_total 
			if commande.remise_bn_commande > 0 :
				total = ((sous_total + commande.ajustement) * commande.remise_bn_commande) / 100 
			else :
				total = sous_total + commande.ajustement 

		context['articlecommandee'] = articlecommandee
		context['commande'] = commande
		context['total'] = total
		context['sous_total'] = sous_total

		address_fact = Address.objects.filter(client = commande.client).filter(type_Ad = 'facturation').order_by('created_at').reverse()
		address_livr = Address.objects.filter(client = commande.client).filter(type_Ad = 'livraison').order_by('created_at').reverse()
		context['address_fact'] = address_fact
		context['address_livr'] = address_livr
		context['liste_conditionsPaiement'] = ConditionPaiement.objects.all().values()


	return render(request, 'convertir-en-facture-fournisseur.html', context)


@login_required(login_url="/login/")
def supprimer_commande(request):

	if request.method == "POST":
		id_commande = request.POST.get('commande')
		type_commande = request.POST.get('type')
		commande = Commande.objects.get(id = id_commande)
		articlecommandee = ArticleCommandee.objects.filter(commande = commande)
		for i in range(len(articlecommandee)) :
			id_art = articlecommandee[i].article.id
			art = Article.objects.get(id = id_art)
			new_stock_comptable_disponible = art.stock_comptable_disponible + articlecommandee[i].qantite_total
			Article.objects.filter(id = art.id).update(stock_comptable_disponible = new_stock_comptable_disponible) 

			id_lot = articlecommandee[i].lot.id
			lot = Lot.objects.get(id = id_lot) 
			new_stock = lot.quantitee + articlecommandee[i].qantite_total
			Lot.objects.filter(id = lot.id).update(quantitee = new_stock)

			
		commande.delete()
		messages.info(request , 'commande bien supprimé')			
		if type_commande == 'bon_commande' :
			return redirect('liste_bon_commandes')
	
	return redirect('liste_commandes')
@login_required(login_url="/login/")
def afficher_modifier_commande(request):
	context={}
	if request.method == "POST":
		id_commande = request.POST.get('commande')
		commande = Commande.objects.get(id = id_commande)
		liste_article = []
		article_commande = ArticleCommandee.objects.filter(commande = commande)
		for i in range(len(article_commande)) :
			if article_commande[i].article :
					liste_article.append(article_commande[i])

		context['commande'] = commande 
		context['liste_article'] = liste_article
		context['liste_clients'] = Client.objects.filter()
		liste_articles = []
		artilces = Article.objects.all()
		for i in artilces :
			if Lot.objects.all().filter(article = i).exists():
				liste_articles.append(i)
			
	context['liste_articles'] = liste_articles


	return render(request, 'modifier-commande.html', context)


@login_required(login_url="/login/")
def valider_modifier_commande(request):
	context={}
	if request.method == "POST":
		id_commande = request.POST.get('commande')
		commande = Commande.objects.get(id = id_commande)
		id_client = request.POST.get('client')
		if id_client :
			client = Client.objects.get(id = id_client)
			Commande.objects.filter(id = id_commande).update(client = client)
		date = request.POST.get('date')
		date_paiement = request.POST.get('date_paiement')
		sous_total = request.POST.get('sous_total')
		frais_expedition = request.POST.get('frais_expedition')
		ajustement = request.POST.get('ajustement')
		total = request.POST.get('total')
		note = request.POST.get('note')
		
		ancien_total = Commande.objects.get(id = id_commande).total
		ancien_reste = Commande.objects.get(id = id_commande).reste

		reste_new =  decimal.Decimal(total) - (ancien_total - ancien_reste)
		if reste_new > 0 : 
			Commande.objects.filter(id = id_commande).update(paiement = 'partiellement payee')
		if reste_new == 0 :
			Commande.objects.filter(id = id_commande).update(paiement = 'paye')
		elif decimal.Decimal(total) == reste_new  :
			Commande.objects.filter(id = id_commande).update(paiement = 'impaye')

		Commande.objects.filter(id = id_commande).update(date = date)
		if date_paiement :
			Commande.objects.filter(id = id_commande).update(date_paiement = date_paiement)
		Commande.objects.filter(id = id_commande).update(sous_total = sous_total)
		Commande.objects.filter(id = id_commande).update(frais_expedition = frais_expedition)
		Commande.objects.filter(id = id_commande).update(ajustement = ajustement)
		Commande.objects.filter(id = id_commande).update(total = total)
		Commande.objects.filter(id = id_commande).update(reste = reste_new)
		Commande.objects.filter(id = id_commande).update(note = note)
	
		article_commande = request.POST.getlist('article_commande[]')
		article = request.POST.getlist('article_options[]')
		lot = request.POST.getlist('lots_options[]')
		qantite = request.POST.getlist('qantite_options[]')
		taux = request.POST.getlist('taux_options[]')
		remise = request.POST.getlist('remise_options[]')
		taxe = request.POST.getlist('taxe_options[]')
		montant = request.POST.getlist('montant_options[]')
		description = request.POST.getlist('description_options[]')		


 		# modifier article
		for i in range(len(article_commande)):
					articlecom = ArticleCommandee.objects.get(id = article_commande[i])
					id_article = articlecom.article.id
					art = Article.objects.get(id = id_article)
					lot_obj = Lot.objects.get(id = articlecom.lot.id)
					if decimal.Decimal(qantite[i]) > articlecom.qantite_total :
						qantite_nouv = decimal.Decimal(qantite[i]) - articlecom.qantite_total 
						new_stock_comptable_disponible = art.stock_comptable_disponible - qantite_nouv
						Article.objects.filter(id = id_article).update(stock_comptable_disponible = new_stock_comptable_disponible)
						new_stock = lot_obj.quantitee - qantite_nouv
						Lot.objects.filter(id = lot_obj.id).update(quantitee = new_stock)
		 
					else :
						qantite_nouv =  articlecom.qantite_total - decimal.Decimal(qantite[i] )
						new_stock_comptable_disponible = art.stock_comptable_disponible + qantite_nouv
						Article.objects.filter(id = id_article).update(stock_comptable_disponible = new_stock_comptable_disponible)
						new_stock = lot_obj.quantitee + qantite_nouv
						Lot.objects.filter(id = lot_obj.id).update(quantitee = new_stock)
			

					
					id_article = article[i].split()[0]
					articleobj = Article.objects.get(id=id_article)
					id_lot = lot[i].split()[0]
					lot_obj = Lot.objects.get(id=id_lot)
					# ArticleCommandee.objects.filter(id = article_commande[i]).update(qantite_reste = qantite_reste)
					ArticleCommandee.objects.filter(id = article_commande[i]).update(article = articleobj)
					ArticleCommandee.objects.filter(id = article_commande[i]).update(lot = lot_obj)
					# ArticleCommandee.objects.filter(id = article_commande[i]).update(reste_emballee =reste_emballee)
					ArticleCommandee.objects.filter(id = article_commande[i]).update(qantite_total = qantite[i])
					ArticleCommandee.objects.filter(id = article_commande[i]).update(taxe = taxe[i])
					ArticleCommandee.objects.filter(id = article_commande[i]).update(montant = montant[i])
					# ArticleCommandee.objects.filter(id = article_commande[i]).update(montant_reste = montant_reste)
					ArticleCommandee.objects.filter(id = article_commande[i]).update(description = description[i])
					ArticleCommandee.objects.filter(id = article_commande[i]).update(remise = remise[i])
					ArticleCommandee.objects.filter(id = article_commande[i]).update(taux = taux[i])


		# Supp ARTICLE Commande 				
		liste_art_supp = request.POST.getlist('article_commande_supprimer[]')	
		if liste_art_supp[0] != '' :
			print('liste art ',liste_art_supp)
			for i in range(len(liste_art_supp)):
					articlC = ArticleCommandee.objects.get(id = liste_art_supp[i])
					articleobjsup = Article.objects.get(id=articlC.article.id)
					new_stock_comptable_disponible = articleobjsup.stock_comptable_disponible + articlC.qantite_total
					Article.objects.filter(id = articlC.article.id).update(stock_comptable_disponible = new_stock_comptable_disponible)

					lot = Lot.objects.get(id = articlC.lot.id) 
					new_stock = lot.quantitee + articlC.qantite_total
					Lot.objects.filter(id = articlC.lot.id).update(quantitee = new_stock)
					articlC.delete()


     # ADD NEW ARTICLE
		article_new = request.POST.getlist('article_options_new[]')
		if len(article_new) >0 :
			lot_new = request.POST.getlist('lots_options_new[]')
			qantite_new = request.POST.getlist('qantite_options_new[]')
			taux_new = request.POST.getlist('taux_options_new[]')
			remise_new = request.POST.getlist('remise_options_new[]')
			taxe_new = request.POST.getlist('taxe_options_new[]')
			montant_new = request.POST.getlist('montant_options_new[]')
			description_new = request.POST.getlist('description_options_new[]')
			for i in range(len(article_new)):
					id_article = article_new[i].split()[0]
					articleobj = Article.objects.get(id=id_article)
					id_lot = lot_new[i].split()[0]
					lot_obj = Lot.objects.get(id=id_lot)
					articlecommandee = ArticleCommandee(commande = commande ,article = articleobj , lot = lot_obj,qantite_total=qantite_new[i] , taxe=taxe_new[i] ,remise = remise_new[i] ,montant =montant_new[i] , description = description_new[i] , taux = taux_new[i])
					articlecommandee.save()	

					last_articlecommandee = ArticleCommandee.objects.last().id
					articlecommandeenew = ArticleCommandee.objects.get(id = last_articlecommandee)
					lot_quantite = articlecommandeenew.lot.quantitee
					articlecommandee_quantite = articlecommandeenew.qantite_total
					qt = lot_quantite
					if lot_quantite > 0 and articlecommandee_quantite > lot_quantite :
						new_stock = lot_obj.quantitee - lot_quantite					
						while qt < articlecommandee_quantite : 
							dif_qt = articlecommandee_quantite - qt
							new_lot = Lot.objects.filter(article = articlecommandeenew.article).order_by('created_at').exclude(quantitee=0).exclude(id =articlecommandeenew.lot.id) 				
							second_lot = new_lot[1]
							if second_lot.quantitee >= dif_qt :
									qt = qt + dif_qt
									new_articlecommandee = ArticleCommandee(commande =articlecommandeenew.commande ,article = articlecommandeenew.article , lot = second_lot,qantite_total= dif_qt  )
									new_articlecommandee.save()
							elif second_lot.quantitee < dif_qt :
									qt = qt + new_lot.quantitee  
									new_articlecommandee = ArticleCommandee(commande = articlecommandeenew.commande ,article = articlecommandeenew.article , lot = new_lot,qantite_total= new_lot.quantitee )
									new_articlecommandee.save()
						
						ArticleCommandee.objects.filter(id = articlecommandeenew.id).update(qantite_total = lot_quantite)
					else :
						new_stock = lot_obj.quantitee - articlecommandee_quantite					
					id_art = articlecommandeenew.article.id
					art = Article.objects.get(id = id_art)
					new_stock_comptable_disponible = art.stock_comptable_disponible - articlecommandee_quantite
					Article.objects.filter(id = art.id).update(stock_comptable_disponible = new_stock_comptable_disponible)
					Lot.objects.filter(id = lot_obj.id).update(quantitee = new_stock)

		messages.info(request , 'commande bien modifer')
	return redirect('liste_commandes')




@login_required(login_url="/login/")
@allowed_users(allowed_roles=['admingestion','assistante'])
def afficher_modifier_bon_commande(request):
	context={}
	if request.method == "POST":
		id_commande = request.POST.get('commande')
		commande = Commande.objects.get(id = id_commande)
		article_commande = ArticleCommandee.objects.filter(commande = commande).order_by('created_at') 
		context['bn_commande'] = commande 
		context['liste_article'] = article_commande
		context['liste_fournisseurs'] = Fournisseur.objects.filter(status = 'actif')
		context['liste_articles'] = Article.objects.all()
	return render(request, 'modifier-bon-commande.html', context)

@login_required(login_url="/login/")
@allowed_users(allowed_roles=['admingestion','assistante'])
def valider_modifier_bon_commande(request):
	context={}
	if request.method == "POST":
		id_commande = request.POST.get('bn_commande')
		commande = Commande.objects.get(id = id_commande)
		id_fournisseur = request.POST.get('fournisseur')
		if id_fournisseur :
			fournisseur = Fournisseur.objects.get(id = id_fournisseur)
			Commande.objects.filter(id = id_commande).update(fournisseur = fournisseur)
		
		date = request.POST.get('date')
		date_paiement = request.POST.get('date_paiement')
		sous_total = request.POST.get('sous_total')
		remise_bn_commande = request.POST.get('remise_bn_commande')
		ajustement = request.POST.get('ajustement')
		total = request.POST.get('total')
		note = request.POST.get('note')	

		ancien_total = Commande.objects.get(id = id_commande).total
		ancien_reste = Commande.objects.get(id = id_commande).reste
		reste_new =  decimal.Decimal(total) - (ancien_total - ancien_reste)
		print ('reste_new ' ,reste_new)
		if reste_new ==  decimal.Decimal(total) : 
			Commande.objects.filter(id = id_commande).update(paiement = 'impaye')
		elif reste_new == 0 :
			Commande.objects.filter(id = id_commande).update(paiement = 'paye')
		else :
			Commande.objects.filter(id = id_commande).update(paiement = 'partiellement payee')

		
		Commande.objects.filter(id = id_commande).update(date = date)
		Commande.objects.filter(id = id_commande).update(date_paiement = date_paiement)
		Commande.objects.filter(id = id_commande).update(note = note)
		Commande.objects.filter(id = id_commande).update(sous_total = sous_total)
		Commande.objects.filter(id = id_commande).update(remise_bn_commande = remise_bn_commande)
		Commande.objects.filter(id = id_commande).update(ajustement = ajustement)
		Commande.objects.filter(id = id_commande).update(total = total)
		Commande.objects.filter(id = id_commande).update(reste = reste_new)



			
		article_commande = request.POST.getlist('article_commande[]')
		qantite = request.POST.getlist('qantite_options[]')
		taux = request.POST.getlist('taux_options[]')
		taxe = request.POST.getlist('taxe_options[]')
		montant = request.POST.getlist('montant_options[]')
		description = request.POST.getlist('description_options[]')		

		
 		# modifier article
		for i in range(len(article_commande)):
					articlecom = ArticleCommandee.objects.get(id = article_commande[i])
					id_article = articlecom.article.id
					art = Article.objects.get(id = id_article)
					if decimal.Decimal(qantite[i]) > articlecom.qantite_total :
						qantite_nouv = decimal.Decimal(qantite[i]) - articlecom.qantite_total 
						new_stock_comptable_disponible = art.stock_comptable_disponible + qantite_nouv
						new_quantitee_non_declarer_comme_lot = art.quantitee_non_declarer_comme_lot + qantite_nouv
						# qantite_reste = articlecom.qantite_reste +  qantite_nouv						
						# mantant_nouv = decimal.Decimal(montant[i]) - articlecom.montant 
						# montant_reste = articlecom.montant_reste + mantant_nouv
					else :
						qantite_nouv =  articlecom.qantite_total - decimal.Decimal(qantite[i] )
						new_stock_comptable_disponible = art.stock_comptable_disponible - qantite_nouv
						new_quantitee_non_declarer_comme_lot = art.quantitee_non_declarer_comme_lot - qantite_nouv
						# qantite_reste = articlecom.qantite_reste -  qantite_nouv
						# mantant_nouv =  articlecom.montant  - decimal.Decimal(montant[i]) 
						# montant_reste = articlecom.montant_reste -  mantant_nouv

					# ArticleCommandee.objects.filter(id = article_commande[i]).update(qantite_reste = qantite_reste)
					ArticleCommandee.objects.filter(id = article_commande[i]).update(qantite_total = qantite[i])
					ArticleCommandee.objects.filter(id = article_commande[i]).update(taxe = taxe[i])
					ArticleCommandee.objects.filter(id = article_commande[i]).update(montant = montant[i])
					# ArticleCommandee.objects.filter(id = article_commande[i]).update(montant_reste = montant_reste)
					ArticleCommandee.objects.filter(id = article_commande[i]).update(description = description[i])
					ArticleCommandee.objects.filter(id = article_commande[i]).update(taux = taux[i])
					Article.objects.filter(id = id_article).update(stock_comptable_disponible = new_stock_comptable_disponible)
					Article.objects.filter(id = id_article).update(quantitee_non_declarer_comme_lot = new_quantitee_non_declarer_comme_lot)		

			
	# Supp ARTICLE Commande 				
		liste_art_supp = request.POST.getlist('article_commande_supprimer[]')	
		if liste_art_supp[0] != '' :
			print('liste art ',liste_art_supp)
			for i in range(len(liste_art_supp)):
					articlC = ArticleCommandee.objects.get(id = liste_art_supp[i])				
					art = Article.objects.get(id = articlC.article.id)
					new_stock_comptable_disponible = art.stock_comptable_disponible - articlC.qantite_total
					new_quantitee_non_declarer_comme_lot = art.quantitee_non_declarer_comme_lot - articlC.qantite_total
					Article.objects.filter(id = articlC.article.id).update(stock_comptable_disponible = new_stock_comptable_disponible)
					Article.objects.filter(id = articlC.article.id).update(quantitee_non_declarer_comme_lot = new_quantitee_non_declarer_comme_lot)	
					articlC.delete()
		
     # ADD NEW ARTICLE
		article_new = request.POST.getlist('article_options_new[]')
		if len(article_new) >0 :
			qantite_new = request.POST.getlist('qantite_options_new[]')
			taux_new = request.POST.getlist('taux_options_new[]')
			taxe_new = request.POST.getlist('taxe_options_new[]')
			montant_new = request.POST.getlist('montant_options_new[]')
			description_new = request.POST.getlist('description_options_new[]')
			for i in range(len(article_new)):
					id_article = article_new[i].split()[0]
					articleobj = Article.objects.get(id=id_article)
					articlecommandee = ArticleCommandee(commande = commande ,article = articleobj ,qantite_total=qantite_new[i] , taxe=taxe_new[i]   ,montant =montant_new[i] ,qantite_reste =qantite_new[i] ,montant_reste =  montant_new[i] , description = description_new[i] , taux = taux_new[i],reste_emballee = qantite_new[i])
					articlecommandee.save()	
					new_stock_comptable_disponible = articleobj.stock_comptable_disponible + decimal.Decimal(qantite_new[i])
					new_quantitee_non_declarer_comme_lot = articleobj.quantitee_non_declarer_comme_lot + decimal.Decimal(qantite_new[i])
					Article.objects.filter(id = id_article).update(stock_comptable_disponible = new_stock_comptable_disponible)
					Article.objects.filter(id = id_article).update(quantitee_non_declarer_comme_lot = new_quantitee_non_declarer_comme_lot)
					
		# artclecom = ArticleCommandee.objects.filter(commande=commande)
		# list_facture = Facture.objects.filter(commande = commande)

		# qantite_reste = 0
		# reste_facture = 0
		# rest_recu_total = 0
		# montant_total = 0

		# qantite_totaly = 0
		# for a in artclecom : 
		# 	qantite_reste = qantite_reste + a.qantite_reste
		# 	rest_recu_total = rest_recu_total + (a.qantite_total - a.qantite_recu)
		# 	qantite_totaly  = qantite_totaly + a.qantite_total

		# if list_facture :
		# 	for fa in list_facture :
		# 		reste_facture  = fa.reste + reste_facture
		# 		montant_total = montant_total + fa.total
		
		# if rest_recu_total == 0  :
		# 	Commande.objects.filter(id = id_commande).update(reçu = 'Reçu')
		# 	if Commande.objects.get(id = id_commande).facturee == 'facturee':
		# 		Commande.objects.filter(id = id_commande).update(status = 'Fermer')
		# elif  rest_recu_total == qantite_totaly :
		# 	Commande.objects.filter(id = id_commande).update(reçu = 'Non reçu')
		# else :
		# 	Commande.objects.filter(id = id_commande).update(reçu = 'Partiellement reçu')


		# if qantite_reste == 0 :
		# 	Commande.objects.filter(id = id_commande).update(facturee = 'facturee')
			
		# 	if Commande.objects.get(id = id_commande).reçu == 'Reçu':
		# 		Commande.objects.filter(id = id_commande).update(status = 'FERME')
		# 	else :
		# 		Commande.objects.filter(id = id_commande).update(status = 'Emise')

		# 	if 	reste_facture == 0 :
		# 			Commande.objects.filter(id = commande.id).update(paiement ='Paye')
		# 	elif reste_facture ==  montant_total :
		# 		Commande.objects.filter(id =commande.id).update(paiement ='Impaye')
		# 	else :
		# 		Commande.objects.filter(id =commande.id).update(paiement ='Partiellement payee')		
			
		# elif qantite_reste !=  qantite_totaly :
		# 	if 	reste_facture ==  montant_total :
		# 		Commande.objects.filter(id =commande.id).update(paiement ='Impaye')
		# 	else:
		# 		Commande.objects.filter(id =commande.id).update(paiement ='Partiellement payee')		

		# 	Commande.objects.filter(id = id_commande).update(facturee = 'Partiellement facturee')
		# 	Commande.objects.filter(id = id_commande).update(status = 'Emise')
		messages.info(request , 'Bon de commande bien modifer')
	return redirect('liste_bon_commandes')



@login_required(login_url="/login/")
@allowed_users(allowed_roles=['admingestion','assistante'])
def supprimer_bon_commande(request):

	if request.method == "POST":
		id_commande = request.POST.get('commande')
		type_commande = request.POST.get('type')

		commande = Commande.objects.get(id = id_commande)

		if commande.paiement =='impaye' :
			articlecommandee = ArticleCommandee.objects.filter(commande = commande)
			for i in range(len(articlecommandee)) :
				id_art = articlecommandee[i].article.id
				art = Article.objects.get(id = id_art)
				new_stock_comptable_disponible = art.stock_comptable_disponible - articlecommandee[i].qantite_total
				Article.objects.filter(id = art.id).update(stock_comptable_disponible = new_stock_comptable_disponible) 
				new_quantitee_non_declarer_comme_lot = art.quantitee_non_declarer_comme_lot - articlecommandee[i].qantite_total
				Article.objects.filter(id = art.id).update(quantitee_non_declarer_comme_lot = new_quantitee_non_declarer_comme_lot)
			commande.delete()
			messages.info(request , 'commande bien supprimé')			
		else :
			messages.info(request, 'Ce contact ne peut pas être supprimé car il est associé à des transactions ou des documents')	

		if type_commande == 'bon_commande' :
			return redirect('liste_bon_commandes')
	
	return redirect('liste_commandes')	