from django.shortcuts import render ,redirect
from colis.models import Colis
from django.db.models import Q
from commandes.models import Commande
from factures.models import Facture
from articlescommandeefactures.models import Articlescommandeefactures
from articles.models import Article
from articlescommandee.models import ArticleCommandee
from operator import itemgetter
from datetime import date
from datetime import date, timedelta
from django.http import JsonResponse
import decimal
from django.contrib.auth.decorators import login_required
import json
from paiements.models import Paiement
from detailsgroupspaiement.models import Detailsgrouppaiement
from remboursements.models import Remboursement
from facturesdavoir.models import Facture_d_avoir
from facturesdavoirfournisseurs.models import Facture_d_avoir_fournisseur
from core.decorators import allowed_users
from django.contrib.auth.decorators import login_required
# Create your views here.
@login_required(login_url="/login/")
@allowed_users(allowed_roles=['admingestion'])
def afficherDashboard(request):

	context = {}
	context['segment'] = 'dashboard'
	qteemballe = 0 
	qteexpedie = 0
	qtelivree = 0
	qtepayee = 0
	qteStock = 0
	qteArecevoir = 0
	liste_colis_nonexpedie = Colis.objects.filter(status ='NON EXPEDIE')
	liste_colis_expedie = Colis.objects.filter(status ='EXPEDIE')
	liste_colis_livree = Colis.objects.filter(status ='LIVRE')
	liste_commande = Commande.objects.filter( Q(paiement='paye') | Q(paiement='partiellement payee')).exclude(client = None)
	liste_bncommande = Commande.objects.all().exclude(fournisseur = None)
	liste_articlecommande = ArticleCommandee.objects.filter(commande__in=liste_bncommande.values_list('id', flat=True))
	liste_art = ArticleCommandee.objects.filter(commande__in=liste_commande.values_list('id', flat=True))

	# liste_payement = Paiement.objects.filter(commande__in=liste_commande.values_list('id', flat=True))
	# liste_articlefacture = Articlescommandeefactures.objects.filter(facture__in=liste_facture.values_list('id', flat=True))
	liste_article = Article.objects.all()
	listearctile = []
	new_liste = []

	print('liste_bncommande' ,liste_bncommande)
	print('liste_articlecommande' ,liste_articlecommande)
	for artf in liste_art :
		qtepayee = qtepayee + artf.qantite_total

	for  c in liste_colis_nonexpedie :
		qteemballe = qteemballe + c.qantite

	for  c in liste_colis_expedie :
		qteexpedie = qteexpedie + c.qantite

	for  c in liste_colis_livree :
		qtelivree = qtelivree + c.qantite 

	for  i  in  range(len(liste_article))  :
		qteStock = qteStock + liste_article[i].stock_comptable_disponible 
		nbrartccomm = ArticleCommandee.objects.filter(article = liste_article[i]).count()
		if nbrartccomm > 0:
			lisd = {'article' : liste_article[i].nom_article,'id_article' : str(liste_article[i].id), 'qantite_total' : str(liste_article[i].stock_comptable_disponible ) , 'tem' : nbrartccomm}
			new_liste.append(lisd) 

	print(sorted(new_liste, key=lambda item: item['tem'] , reverse=True))

	for  artcom in liste_articlecommande :
		qteArecevoir = qteArecevoir + artcom.qantite_total 

	context['qteemballe'] =qteemballe	
	context['qteexpedie'] =qteexpedie	
	context['qtelivree'] =qtelivree
	context['qtepaye'] =qtepayee	
	context['qteStock'] =qteStock
	context['qteArecevoir'] =qteArecevoir	
	context['listearctile'] = new_liste	
	context['totArt'] = Article.objects.all().count()

	context['ArtfaibleStock'] = Article.objects.filter(stock_comptable_disponible__lte = 2).count()
	# context['CommandeBrouillon'] = Commande.objects.filter(status = 'BROUILLON').exclude(ctype_commande = 'bon_commande').count()
	context['CommandeFacture'] = Commande.objects.filter(Q(paiement='payee') | Q(paiement='partiellement payee')).exclude(type_commande = 'bon_commande').count()
	context['CommandeExpedie'] = Commande.objects.filter(Q(expiditions='traite') | Q(expiditions='partiellement expedie')).exclude(type_commande = 'bon_commande').count()
	context['CommandeEmballe'] = Commande.objects.filter(Q(emballage='emballee') | Q(emballage='partiellement emballe')).exclude(type_commande = 'bon_commande').count()
	# context['CommandeFermer'] = Commande.objects.filter(status = 'FERME').exclude(client = None).count()
	# context['CommandeConfirmer'] = Commande.objects.filter(status = 'CONFIRMEE').exclude(client = None).count()

	enddate = date.today()
	startdate = enddate - timedelta(days=7)
	commande = Commande.objects.filter(date__range=[startdate, enddate])
	paiement = Paiement.objects.filter(created_at__range=[startdate, enddate])
	liste_articlecommandeqte = ArticleCommandee.objects.filter(commande__in=commande.values_list('id', flat=True))
	# liste_Articlescommandeefactures = Articlescommandeefactures.objects.filter(facture__in=facture.values_list('id', flat=True))
	montant_paye = 0
	qte_facture =0
	for art in paiement :
		# qte_facture = qte_facture + art.qantite
		montant_paye = art.montant + montant_paye


	qte_commande =0
	montant_t = 0
	for art in liste_articlecommandeqte :
		qte_commande = qte_commande + art.qantite_total
		montant_t = art.montant +montant_t


	context['qte_commande'] = qte_commande
	context['montant_t'] = montant_t
	# context['qte_facture'] = qte_facture
	context['montant_facture'] = montant_paye

# ----------- calcule total paiement pour client fournisseur---------------------------------------
	# list_paiementClient_total = Paiement.objects.filter(facture__in=Facture.objects.all().exclude(client = None).values_list('id', flat=True))
	# list_grouppaiementClient_total = Detailsgrouppaiement.objects.filter(facture__in=Facture.objects.all().exclude(client = None).values_list('id', flat=True))

	list_paiementFournisseur_total = Paiement.objects.filter(commande__in= Commande.objects.all().exclude(type_commande = 'commande').values_list('id', flat=True))
	list_grouppaiementFournisseur_total = Detailsgrouppaiement.objects.filter(commande__in=Commande.objects.all().exclude(type_commande = 'commande').values_list('id', flat=True))
	
	# total_montant_payee = 0
	# for paiement in list_paiementClient_total :
	# 	if paiement.cheque :
	# 		if paiement.cheque.status != 'invalid':
	# 			total_montant_payee = total_montant_payee + paiement.montant
	# 	else :
	# 		total_montant_payee = total_montant_payee + paiement.montant 
	
	# for paiement in list_grouppaiementClient_total :
	# 	if paiement.grouppaiement.cheque :
	# 		if paiement.grouppaiement.cheque.status != 'invalid':
	# 			total_montant_payee = total_montant_payee + paiement.montant
	# 	else :
	# 		total_montant_payee = total_montant_payee + paiement.montant 

	total_montant_payee_f = 0
	for paiement in list_paiementFournisseur_total :
		total_montant_payee_f = total_montant_payee_f + paiement.montant

	for paiement in list_grouppaiementFournisseur_total :
		total_montant_payee_f = total_montant_payee_f + paiement.montant

	# context['total_montant_payee'] = total_montant_payee
	context['total_montant_payee_f'] = total_montant_payee_f
# -------------------------------------------------------------------------------------------------
# ----------- calcule total paiement pour Retour client fournisseur---------------------------------------

	list_remboursementClient_total = Remboursement.objects.all().exclude(facture_d_avoir = None )	
	list_remboursementFournisseur_total = Remboursement.objects.all().exclude(Facture_d_avoir_fournisseur = None)
	total_montant_rembourserClient = 0
	for remb in list_remboursementClient_total :
		total_montant_rembourserClient = total_montant_rembourserClient + remb.montant 

	total_montant_rembourserFournisseur = 0
	for remb in list_remboursementFournisseur_total :
		total_montant_rembourserFournisseur = total_montant_rembourserFournisseur + remb.montant 
	
	context['total_montant_rembourserFournisseur'] = total_montant_rembourserFournisseur
	context['total_montant_rembourserClient'] = total_montant_rembourserClient

# -------------------------------------------------------------------------------------------------

	return render(request, 'dashboard-home.html', context)
@login_required(login_url="/login/")
@allowed_users(allowed_roles=['admingestion'])
def datefiltre(request):
	context = {}
	if request.method == "POST":
		date_debut = request.POST.get('date_debut')
		date_fin = request.POST.get('date_fin')
		commande = Commande.objects.filter(date__range=[date_debut, date_fin])
		print('commande filtre ' ,commande)

	return redirect('afficherDashboard')
@login_required(login_url="/login/")
@allowed_users(allowed_roles=['admingestion'])
def getdetails(request):

    if request.is_ajax and request.method == "GET":
    	new_liste = {}
    	choix = request.GET.get("choix", None)
    	type_recherch = request.GET.get("type", None)
    	enddate = date.today()
    	if choix =='aujourd_hui' or choix =='hier' or  choix =='cette_semaine' :    	
	    	if choix =='aujourd_hui' :
	    		day= 0;
	    	elif choix =='hier' :
	    		day= 1
	    	elif choix =='cette_semaine' :
	    		day= 7

	    	startdate = enddate - timedelta(days=day)
	    	if type_recherch == '1' :
	    		commande = Commande.objects.filter(date__range=[startdate, enddate])
	    		facture = Paiement.objects.filter(created_at__range=[startdate, enddate])
	    	else :
	    		list_paiementClient_total = Paiement.objects.filter(commande__in=Commande.objects.all().exclude(type_commande = 'bon_commande').values_list('id', flat=True)).filter(created_at__range=[startdate, enddate])
	    		list_grouppaiementClient_total = Detailsgrouppaiement.objects.filter(commande__in=Commande.objects.all().exclude(type_commande = 'bon_commande').values_list('id', flat=True)).filter(created_at__range=[startdate, enddate])
	    		list_paiementFournisseur_total = Paiement.objects.filter(commande__in=Commande.objects.all().exclude(type_commande = 'commande').values_list('id', flat=True)).filter(created_at__range=[startdate, enddate])
	    		list_grouppaiementFournisseur_total = Detailsgrouppaiement.objects.filter(commande__in=Commande.objects.all().exclude(type_commande = 'commande').values_list('id', flat=True)).filter(created_at__range=[startdate, enddate])
	    		
	    		list_remboursementClient_total = Remboursement.objects.all().exclude(facture_d_avoir = None ).filter(date_remboursement__range=[startdate, enddate])
	    		list_remboursementFournisseur_total = Remboursement.objects.all().exclude(Facture_d_avoir_fournisseur = None).filter(date_remboursement__range=[startdate, enddate])
    	
    	elif choix =='ce_mois' :
    		if type_recherch == '1' :
	    		commande = Commande.objects.filter(date__month= enddate.month)
	    		facture = Paiement.objects.filter(created_at__month= enddate.month)
	    	elif type_recherch == '2' :
	    		list_paiementClient_total = Paiement.objects.filter(commande__in=Commande.objects.all().exclude(type_commande = 'bon_commande').values_list('id', flat=True)).filter(created_at__month=enddate.month)
	    		list_grouppaiementClient_total = Detailsgrouppaiement.objects.filter(commande__in=Commande.objects.all().exclude(type_commande = 'bon_commande').values_list('id', flat=True)).filter(created_at__month=enddate.month)
	    		list_paiementFournisseur_total = Paiement.objects.filter(commande__in=Commande.objects.all().exclude(type_commande = 'commande').values_list('id', flat=True)).filter(created_at__month=enddate.month)
	    		list_grouppaiementFournisseur_total = Detailsgrouppaiement.objects.filter(commande__in=Commande.objects.all().exclude(type_commande = 'commande').values_list('id', flat=True)).filter(created_at__month=enddate.month)
	    		list_remboursementClient_total = Remboursement.objects.all().exclude(facture_d_avoir = None ).filter(date_remboursement__month=enddate.month)
	    		list_remboursementFournisseur_total = Remboursement.objects.all().exclude(Facture_d_avoir_fournisseur = None).filter(date_remboursement__month=enddate.month)

    	elif choix =='cette_annee' :
    		if type_recherch == '1' :
	    		commande = Commande.objects.filter(date__year= enddate.year)
	    		facture = Paiement.objects.filter(created_at__year= enddate.year)
	    	elif type_recherch == '2' :
	    		list_paiementClient_total = Paiement.objects.filter(commande__in=Commande.objects.all().exclude(type_commande = 'bon_commande').values_list('id', flat=True)).filter(created_at__year=enddate.year)
	    		list_grouppaiementClient_total = Detailsgrouppaiement.objects.filter(commande__in=Commande.objects.all().exclude(type_commande = 'bon_commande').values_list('id', flat=True)).filter(created_at__year=enddate.year)
	    		list_paiementFournisseur_total = Paiement.objects.filter(commande__in=Commande.objects.all().exclude(type_commande = 'commande').values_list('id', flat=True)).filter(created_at__year=enddate.year)
	    		list_grouppaiementFournisseur_total = Detailsgrouppaiement.objects.filter(commande__in=Commande.objects.all().exclude(type_commande = 'commande').values_list('id', flat=True)).filter(created_at__year=enddate.year)
	    		list_remboursementClient_total = Remboursement.objects.all().exclude(facture_d_avoir = None ).filter(date_remboursement__year=enddate.year)
	    		list_remboursementFournisseur_total = Remboursement.objects.all().exclude(Facture_d_avoir_fournisseur = None).filter(date_remboursement__year=enddate.year)


    	if type_recherch == '1' :
	    	liste_articlecommandeqte = ArticleCommandee.objects.filter(commande__in=commande.values_list('id', flat=True))
	    	# liste_Articlescommandeefactures = Articlescommandeefactures.objects.filter(facture__in=facture.values_list('id', flat=True))
	    	montant_t = 0
	    	qte_commande =0
	    	for art in liste_articlecommandeqte :
	    		qte_commande = qte_commande + art.qantite_total
	    		montant_t = art.montant +montant_t

	    	montant_facture = 0
	    	for art in facture :
	    		montant_facture = art.montant + montant_facture

	    	lisd = {'montant_t' : str(montant_t) ,'qte_commande':str(qte_commande) ,'montant_facture' : str(montant_facture)}
    	
    	elif type_recherch == '2' :
	    	total_montant_payee = 0
	    	for paiement in list_paiementClient_total :
	    		total_montant_payee = total_montant_payee + paiement.montant 
	    	
	    	for paiement in list_grouppaiementClient_total :
	    		total_montant_payee = total_montant_payee + paiement.montant 
	    
	    	total_montant_payee_f = 0
	    	for paiement in list_paiementFournisseur_total :
	    		total_montant_payee_f = total_montant_payee_f + paiement.montant

	    	for paiement in list_grouppaiementFournisseur_total :
	    		total_montant_payee_f = total_montant_payee_f + paiement.montant

	    	total_montant_rembourserClient = 0
	    	for remb in list_remboursementClient_total :
	    		total_montant_rembourserClient = total_montant_rembourserClient + remb.montant 
	    
	    	total_montant_rembourserFournisseur = 0
	    	for remb in list_remboursementFournisseur_total :
	    		total_montant_rembourserFournisseur = total_montant_rembourserFournisseur + remb.montant
	    	
	    	lisd = {'revenu' : str(total_montant_payee) ,'depense':str(total_montant_payee_f) ,'remb_client': str(total_montant_rembourserClient),'remb_fournisseur' : str(total_montant_rembourserFournisseur)}
    	
    	new_liste[0] = lisd
    	print('lisd' ,lisd)
    	data= json.dumps(new_liste)
    	return JsonResponse({"data":data}, status = 200)
    return JsonResponse({}, status = 400)	
@login_required(login_url="/login/")
@allowed_users(allowed_roles=['admingestion'])
def getdetailsdatefiltre(request):
    	
    if request.is_ajax and request.method == "GET":
    	new_liste = {}	
    	date_debut = request.GET.get("date_debut", None)
    	date_fin = request.GET.get("date_fin", None)
    	type_recherch = request.GET.get("type", None)
    	if type_recherch == '1' :
	    	commande = Commande.objects.filter(date__range=[date_debut, date_fin])
	    	paiement = Paiement.objects.filter(created_at__range=[date_debut, date_fin])
	    	liste_articlecommandeqte = ArticleCommandee.objects.filter(commande__in=commande.values_list('id', flat=True))
	    	montant_t = 0
	    	qte_commande =0
	    	for art in liste_articlecommandeqte :
	    		qte_commande = qte_commande + art.qantite_total
	    		montant_t = art.montant +montant_t

	    	# liste_Articlescommandeefactures = Articlescommandeefactures.objects.filter(facture__in=facture.values_list('id', flat=True))
	    	montant_facture = 0
	    	for art in paiement :
	    		montant_facture = art.montant + montant_facture

	    	lisd = {'montant_t' : str(montant_t) ,'qte_commande':str(qte_commande) ,'montant_facture' : str(montant_facture)}
	    
    	elif type_recherch == '2' :
	    	list_paiementClient_total = Paiement.objects.filter(commande__in=Commande.objects.all().exclude(type_commande = 'bon_commande').values_list('id', flat=True)).filter(created_at__range=[date_debut, date_fin])
	    	list_grouppaiementClient_total = Detailsgrouppaiement.objects.filter(commande__in=Commande.objects.all().exclude(type_commande = 'bon_commande').values_list('id', flat=True)).filter(created_at__range=[date_debut, date_fin])
	    	list_paiementFournisseur_total = Paiement.objects.filter(commande__in=Commande.objects.all().exclude(type_commande = 'commande').values_list('id', flat=True)).filter(created_at__range=[date_debut, date_fin])
	    	list_grouppaiementFournisseur_total = Detailsgrouppaiement.objects.filter(commande__in=Commande.objects.all().exclude(type_commande = 'commande').values_list('id', flat=True)).filter(created_at__range=[date_debut, date_fin])
	    	
	    	list_remboursementClient_total = Remboursement.objects.all().exclude(facture_d_avoir = None ).filter(date_remboursement__range=[date_debut, date_fin])
	    	list_remboursementFournisseur_total = Remboursement.objects.all().exclude(Facture_d_avoir_fournisseur = None).filter(date_remboursement__range=[date_debut, date_fin])
	    	total_montant_payee = 0
	    	for paiement in list_paiementClient_total :
	    			total_montant_payee = total_montant_payee + paiement.montant 
	    	
	    	for paiement in list_grouppaiementClient_total :
	    		total_montant_payee = total_montant_payee + paiement.montant 
	    
	    	total_montant_payee_f = 0
	    	for paiement in list_paiementFournisseur_total :
	    		total_montant_payee_f = total_montant_payee_f + paiement.montant

	    	for paiement in list_grouppaiementFournisseur_total :
	    		total_montant_payee_f = total_montant_payee_f + paiement.montant

	    	total_montant_rembourserClient = 0
	    	for remb in list_remboursementClient_total :
	    		total_montant_rembourserClient = total_montant_rembourserClient + remb.montant 
	    
	    	total_montant_rembourserFournisseur = 0
	    	for remb in list_remboursementFournisseur_total :	
	    		total_montant_rembourserFournisseur = total_montant_rembourserFournisseur + remb.montant
	    	
	    	lisd = {'revenu' : str(total_montant_payee) ,'depense':str(total_montant_payee_f) ,'remb_client': str(total_montant_rembourserClient),'remb_fournisseur' : str(total_montant_rembourserFournisseur)}
    	
    	new_liste[0] = lisd
    	print('lisd' ,lisd)
    	data= json.dumps(new_liste)
    	return JsonResponse({"data":data}, status = 200)
    return JsonResponse({}, status = 400)	
@login_required(login_url="/login/")
@allowed_users(allowed_roles=['admingestion'])
def getdetailscountcommande(request):
    	
    if request.is_ajax and request.method == "GET":
    	new_liste = {}	
    	choix = request.GET.get("choix", None)
    	enddate = date.today()
    	if choix =='aujourd_hui' or choix =='hier' or  choix =='cette_semaine' :    	
	    	if choix =='aujourd_hui' :
	    		day= 0;
	    	elif choix =='hier' :
	    		day= 1
	    	elif choix =='cette_semaine' :
	    		day= 7
	    	startdate = enddate - timedelta(days=day)
	    	# CommandeBrouillon = Commande.objects.filter(status = 'BROUILLON').exclude(client = None).filter(date__range=[startdate, enddate]).count()
	    	CommandeFacture = Commande.objects.filter(Q(paiement='paye') | Q(paiement='partiellement payee')).filter(date__range=[startdate, enddate]).exclude(type_commande = 'bon_commande').count()
	    	CommandeExpedie =Commande.objects.filter(Q(expiditions='traite') | Q(expiditions='partiellement expedie')).filter(date__range=[startdate, enddate]).exclude(type_commande = 'bon_commande').count()
	    	CommandeEmballe = Commande.objects.filter(Q(emballage='emballee') | Q(emballage='partiellement emballe')).filter(date__range=[startdate, enddate]).exclude(type_commande = 'bon_commande').count()
	    	# CommandeFermer = Commande.objects.filter(status = 'FERME').exclude(client = None).filter(date__range=[startdate, enddate]).count()
	    	# CommandeConfirmer = Commande.objects.filter(status = 'CONFIRMEE').exclude(client = None).filter(date__range=[startdate, enddate]).count()
    	elif choix =='ce_mois' :
	    	# CommandeBrouillon = Commande.objects.filter(status = 'BROUILLON').exclude(client = None).filter(date__month= enddate.month).count()
	    	CommandeFacture = Commande.objects.filter(Q(facturee='paye') | Q(facturee='partiellement payee')).filter(date__month= enddate.month).exclude(type_commande = 'bon_commande').count()
	    	CommandeExpedie =Commande.objects.filter(Q(expiditions='traite') | Q(expiditions='partiellement expedie')).filter(date__month= enddate.month).exclude(type_commande = 'bon_commande').count()
	    	CommandeEmballe = Commande.objects.filter(Q(emballage='emballee') | Q(emballage='partiellement emballe')).filter(date__month= enddate.month).exclude(type_commande = 'bon_commande'
	    		).count()
	    	# CommandeFermer = Commande.objects.filter(status = 'FERME').exclude(client = None).filter(date__month= enddate.month).count()
	    	# CommandeConfirmer = Commande.objects.filter(status = 'CONFIRMEE').exclude(client = None).filter(date__month= enddate.month).count()
    	elif choix =='cette_annee' :
	    	# CommandeBrouillon = Commande.objects.filter(status = 'BROUILLON').exclude(client = None).filter(date__year= enddate.year).count()
	    	CommandeFacture = Commande.objects.filter(Q(facturee='paye') | Q(facturee='partiellement payee')).filter(date__year= enddate.year).exclude(type_commande = 'bon_commande').count()
	    	CommandeExpedie =Commande.objects.filter(Q(expiditions='traite') | Q(expiditions='partiellement expedie')).filter(date__year= enddate.year).exclude(type_commande = 'bon_commande').count()
	    	CommandeEmballe = Commande.objects.filter(Q(emballage='emballee') | Q(emballage='partiellement emballe')).filter(date__year= enddate.year).exclude(type_commande = 'bon_commande').count()
	    	# CommandeFermer = Commande.objects.filter(status = 'FERME').exclude(client = None).filter(date__year= enddate.year).count()
	    	# CommandeConfirmer = Commande.objects.filter(status = 'CONFIRMEE').exclude(client = None).filter(date__year= enddate.year).count()
	   
    	lisd = {'CommandeFacture':str(CommandeFacture) ,'CommandeExpedie': str(CommandeExpedie),'CommandeEmballe' : str(CommandeEmballe)}
    	new_liste[0] = lisd
    	print('lisd' ,lisd)
    	data= json.dumps(new_liste)
    	return JsonResponse({"data":data}, status = 200)
    return JsonResponse({}, status = 400)
@login_required(login_url="/login/")
@allowed_users(allowed_roles=['admingestion'])
def getdetailsdatecommandefiltre(request):
    	
    if request.is_ajax and request.method == "GET":
    	new_liste = {}	
    	date_debut = request.GET.get("date_debut", None)
    	date_fin = request.GET.get("date_fin", None)
    	# CommandeBrouillon = Commande.objects.filter(status = 'BROUILLON').exclude(client = None).filter(date__range=[date_debut, date_fin]).count()
    	CommandeFacture = Commande.objects.filter(Q(paiement='paye') | Q(paiement='partiellement payee')).filter(date__range=[date_debut, date_fin]).exclude(type_commande = 'bon_commande').count()
    	CommandeExpedie =Commande.objects.filter(Q(expiditions='traite') | Q(expiditions='partiellement expedie')).filter(date__range=[date_debut, date_fin]).exclude(type_commande = 'bon_commande').count()
    	CommandeEmballe = Commande.objects.filter(Q(emballage='emballee') | Q(emballage='partiellement emballe')).filter(date__range=[date_debut, date_fin]).exclude(type_commande = 'bon_commande').count()
    	# CommandeFermer = Commande.objects.filter(status = 'FERME').exclude(client = None).filter(date__range=[date_debut, date_fin]).count()
    	# CommandeConfirmer = Commande.objects.filter(status = 'CONFIRMEE').exclude(client = None).filter(date__range=[date_debut, date_fin]).count()

    	lisd = {'CommandeFacture':str(CommandeFacture) ,'CommandeExpedie': str(CommandeExpedie),'CommandeEmballe' : str(CommandeEmballe)}
    	new_liste[0] = lisd
    	print('lisd' ,lisd)
    	data= json.dumps(new_liste)
    	return JsonResponse({"data":data}, status = 200)
    return JsonResponse({}, status = 400)	