from django.db import models
from decimal import Decimal
from django.core.validators import MinValueValidator
from facturesdavoirfournisseurs.models import Facture_d_avoir_fournisseur
from lots.models import Lot
from articles.models import Article

# Create your models here.
class DetailFactureAvoirFournisseur(models.Model):
	facture_avoir = models.ForeignKey(Facture_d_avoir_fournisseur, on_delete=models.SET_NULL, null=True, blank=True)
	quantitee  = models.DecimalField(decimal_places=0, max_digits=19, blank=True, default=0, validators=[MinValueValidator(Decimal('0.00'))])
	taux = models.DecimalField(decimal_places=2, max_digits=19, blank=True, default=0, validators=[MinValueValidator(Decimal('0.00'))])
	taxe = models.DecimalField(decimal_places=2, max_digits=19, blank=True, default=0, validators=[MinValueValidator(Decimal('0.00'))])
	montant = models.DecimalField(decimal_places=2, max_digits=19, blank=True, default=0, validators=[MinValueValidator(Decimal('0.00'))])
	lot = models.ForeignKey(Lot, on_delete=models.SET_NULL, null=True, blank=True)
	article = models.ForeignKey(Article, on_delete=models.SET_NULL, null=True, blank=True)
	created_at = models.DateTimeField(auto_now_add=True)
	updated_at = models.DateTimeField(auto_now=True)
