from django.db import models
from clients.models import Client
from commandes.models import Commande

from fournisseurs.models import Fournisseur
from django.contrib.auth.models import User
# Create your models here.
class Facture(models.Model):
	commande = models.ForeignKey(Commande, on_delete=models.SET_NULL, null=True, blank=True)
	client = models.ForeignKey(Client, on_delete=models.SET_NULL, null=True, blank=True)
	fournisseur = models.ForeignKey(Fournisseur, on_delete=models.SET_NULL, null=True, blank=True)
	total = models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True)
	status = models.CharField(max_length= 50 , blank=True , null=True)
	reste = models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True)
	date_echeance =models.DateField(null=True, blank=True)
	date = models.DateField(null=True, blank=True)
	sous_total = models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True)
	created_at = models.DateTimeField(auto_now_add=True)
	updated_at = models.DateTimeField(auto_now=True)
	condition_generales = models.CharField(max_length= 250 , blank=True , null=True)
	frais_expedition =  models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True)
	ajustement = models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True)
	info_client = models.CharField(max_length= 250 , blank=True , null=True)
	expiditions = models.CharField(max_length= 100 , blank=True , null=True )
	remise_bn_commande = models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True) 
	num_facture = models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True ,default = 0)
	condition_de_paiement = models.CharField(max_length= 250 , blank=True , null=True)
	user = models.ForeignKey(User, on_delete=models.SET_NULL , null=True, blank=True )