from django.shortcuts import render ,redirect
from factures.forms import FactureForm ,form_validation_error
from factures.models import Facture
from commandes.models import Commande
from articlescommandee.models import ArticleCommandee
from articlescommandeefactures.models import Articlescommandeefactures
from django.contrib import messages
from organisation.models import Organisation
import decimal
from paiements.models import Paiement
from clients.models import Client
from lots.models import Lot
from datetime import date
from articles.models import Article

from django.contrib.auth.decorators import login_required
from fournisseurs.models import Fournisseur
from facturesdavoir.views import  render_to_pdf
from django.views import View
from xhtml2pdf import pisa
from io import BytesIO
from django.http import HttpResponse
from django.template.loader import get_template
from django.core.serializers import serialize
from django.core import serializers
from django.http import JsonResponse
from django.contrib.auth.decorators import login_required
import json
from django.contrib.auth.models import User
from django.contrib.auth.models import Group 
from core.decorators import allowed_users

# Create your views here.

class ViewPDFFacture(View):
	def get(self, request, *args, **kwargs):
		id_facture = request.GET.get('id_facture')
		print('id ',id_facture)
		data = {
			"facture": Facture.objects.get(id = id_facture),
			"Articlescommandeefactures": Articlescommandeefactures.objects.filter(facture_id = id_facture),
		}
		pdf = render_to_pdf('facture.html', data)
		return HttpResponse(pdf, content_type='application/pdf')

class DownloadPDFFacture(View):
	def get(self, request,*args,**kwargs):
		id_facture = request.GET.get('id_facture')
		print('id ',id_facture)
		data = {
			"facture": Facture.objects.get(id = id_facture),
			"Articlescommandeefactures": Articlescommandeefactures.objects.filter(facture_id = id_facture),
		}
		pdf = render_to_pdf('facture.html',data)
		#filename = "Invoice_%s.pdf" %("12341231")
		content = "attachment; filename= facture.pdf"
		response = HttpResponse(pdf,content_type = 'application/pdf')
		response['Content-Disposition'] = content
		return response

class ViewPDFFactureFournisseur(View):
	def get(self, request, *args, **kwargs):
		id_facture = request.GET.get('id_facture')
		print('id ',id_facture)
		data = {
			"facture": Facture.objects.get(id = id_facture),
			"Articlescommandeefactures": Articlescommandeefactures.objects.filter(facture_id = id_facture),
		}
		pdf = render_to_pdf('facture-fournisseur.html', data)
		return HttpResponse(pdf, content_type='application/pdf')

class DownloadPDFFactureFournisseur(View):
	def get(self, request,*args,**kwargs):
		id_facture = request.GET.get('id_facture')
		print('id ',id_facture)
		data = {
			"facture": Facture.objects.get(id = id_facture),
			"Articlescommandeefactures": Articlescommandeefactures.objects.filter(facture_id = id_facture),
		}
		pdf = render_to_pdf('facture-fournisseur.html',data)
		#filename = "Invoice_%s.pdf" %("12341231")
		content = "attachment; filename= facture.pdf"
		response = HttpResponse(pdf,content_type = 'application/pdf')
		response['Content-Disposition'] = content
		return response

@login_required(login_url="/login/")
def ajouter_facture(request):
	context = {}
	context['segment'] = 'commandes'
	context['liste_commandes'] = Commande.objects.all()
	if request.method == "POST":

		articleCommande = request.POST.getlist('article_options[]')
		qantite = request.POST.getlist('qantite_options[]')
		taux = request.POST.getlist('taux_options[]')
		remise = request.POST.getlist('remise_options[]')
		taxe = request.POST.getlist('taxe_options[]')
		montant = request.POST.getlist('montant_options[]')		
		total_f = request.POST.get('total')


		form = FactureForm(request.POST or None)
		if form.is_valid():
			print("is valid")
			form.save()
			last_facture = Facture.objects.last().id
			facture = Facture.objects.get(id = last_facture)
			Facture.objects.filter(id = last_facture).update(status = "BROUILLON")
			Facture.objects.filter(id = last_facture).update(reste = total_f) 
			for i in range(len(qantite)):
				if  decimal.Decimal(qantite[i]) > 0 :
					articlecommande = ArticleCommandee.objects.get( id = articleCommande[i])
					if articlecommande.qantite_reste < decimal.Decimal(qantite[i]) :
						if 	articlecommande.qantite_reste != 0 :
							articlecommandeefacture = Articlescommandeefactures(facture = facture , articleCommandee = articlecommande,qantite=articlecommande.qantite_reste, taxe=taxe[i] ,remise = remise[i] ,montant =montant[i] ,taux =taux[i] )
							articlecommandeefacture.save()
							
							qant = articlecommande.facturee + articlecommande.qantite_reste
							ArticleCommandee.objects.filter(id = articleCommande[i]).update(facturee = qant)
							artcommande = ArticleCommandee.objects.get(id = articleCommande[i])
							qt_r = artcommande.qantite_total - artcommande.facturee

							montant_reste = artcommande.montant_reste - ( decimal.Decimal(qantite[i]) * articlecommande.taux)
							if decimal.Decimal(taxe[i]) > 0 :
								montant_reste = (montant_reste *  articlecommande.taxe ) / 100
							if  decimal.Decimal(remise[i]) > 0 :
								montant_reste = (montant_reste * articlecommande.remise ) / 100

							ArticleCommandee.objects.filter(id = articleCommande[i]).update(qantite_reste = qt_r)
							ArticleCommandee.objects.filter(id = articleCommande[i]).update(montant_reste = montant_reste)


					
							dif_qnt = decimal.Decimal(qantite[i]) - articlecommande.qantite_reste 
							list_article_commande = ArticleCommandee.objects.all().filter(commande=articlecommande.commande).filter(article = articlecommande.article).exclude(id = articleCommande[i] )
							i = 0
							while dif_qnt > 0 and i < len(list_article_commande):	
									if list_article_commande[i].qantite_reste > 0 :
										if dif_qnt >= list_article_commande[i].qantite_reste :
											articlecommandeefacture2 = Articlescommandeefactures(facture = facture , articleCommandee = list_article_commande[i] , qantite=list_article_commande[i].qantite_reste)
											articlecommandeefacture2.save()
											dif_qt = dif_qnt - list_article_commande[i].qantite_reste

											qant2 = list_article_commande[i].facturee + list_article_commande[i].qantite_reste
											ArticleCommandee.objects.filter(id = list_article_commande[i].id).update(facturee = qant2)
											artcommande2 = ArticleCommandee.objects.get(id = list_article_commande[i].id)
											qt_r2 = artcommande2.qantite_total - artcommande2.facturee
											ArticleCommandee.objects.filter(id = list_article_commande[i].id).update(qantite_reste = qt_r2)
										
										else :
											articlecommandeefacture2 = Articlescommandeefactures(facture = facture , articleCommandee = list_article_commande[i] , qantite=dif_qnt)
											articlecommandeefacture2.save()
											dif_qt = list_article_commande[i].qantite_reste - dif_qnt

											qant2 = list_article_commande[i].facturee + dif_qnt
											ArticleCommandee.objects.filter(id = list_article_commande[i].id).update(facturee = qant2)
											artcommande2 = ArticleCommandee.objects.get(id = list_article_commande[i].id)
											qt_r2 = artcommande2.qantite_total - artcommande2.facturee
											ArticleCommandee.objects.filter(id = list_article_commande[i].id).update(qantite_reste = qt_r2)
									i = i+1	  	

					elif articlecommande.qantite_reste >= decimal.Decimal(qantite[i]) :	
						articlecommandeefacture = Articlescommandeefactures(facture = facture , articleCommandee = articlecommande,qantite=qantite[i] , taxe=taxe[i] ,remise = remise[i] ,montant =montant[i] ,taux =taux[i] )
						articlecommandeefacture.save()	


						qant = articlecommande.facturee + decimal.Decimal(qantite[i])
						ArticleCommandee.objects.filter(id = articleCommande[i]).update(facturee = qant)
						artcommande = ArticleCommandee.objects.get(id = articleCommande[i])
						
						qt_r = artcommande.qantite_total - artcommande.facturee
						montant_reste = qt_r  * articlecommande.taux
						if decimal.Decimal(taxe[i]) > 0 :
							montant_reste = (montant_reste *  articlecommande.taxe ) / 100
						if  decimal.Decimal(remise[i]) > 0 :
							montant_reste = (montant_reste * articlecommande.remise ) / 100

						ArticleCommandee.objects.filter(id = articleCommande[i]).update(qantite_reste = qt_r)
						ArticleCommandee.objects.filter(id = articleCommande[i]).update(montant_reste = montant_reste)
			

			id_commande = request.POST.get('commande')
			commande = Commande.objects.get(id = id_commande)
			if commande.status == 'CONFIRMEE' :
				Commande.objects.filter(id = id_commande).update(status = "FERME")
				if commande.total > decimal.Decimal(total_f) :
					Commande.objects.filter(id = id_commande).update(facturee = 'Partiellement facturee')
				elif commande.total == decimal.Decimal(total_f) :
					Commande.objects.filter(id = id_commande).update(facturee = 'facturee')

			elif commande.status == 'FERME' :
				if commande.facturee == 'Partiellement facturee' :
					artclecom = ArticleCommandee.objects.all().filter(commande=commande)
					qantite_reste = 0
					for a in artclecom : 
						qantite_reste = qantite_reste + a.qantite_reste 
					if qantite_reste == 0 :
						Commande.objects.filter(id = id_commande).update(facturee = 'facturee')
					context['qantite_reste'] = qantite_reste
			messages.success(request, 'facture a été bien ajouté et marqué comme BROUILLON ')	
		else :
			messages.error(request, 'facture n est pas correctement ajoutée ')

	return redirect('liste_commandes')

@login_required(login_url="/login/")
def liste_facture(request):
    context = {}
    context['segment'] = 'factures' 
    context['liste_facture'] = Facture.objects.all().exclude(client=None).order_by('date').reverse()
    context['now'] = date.today()
    return render(request, 'liste-factures.html', context)
@login_required(login_url="/login/")
def afficher_facture(request):
	context = {}	
	if request.method == "POST":
		id_facture = request.POST.get('id_facture')
		facture = Facture.objects.get(id = id_facture)
		context['facture'] = facture
		articlecommandeefacture = Articlescommandeefactures.objects.all().filter(facture=facture)
		new_liste = []       
		for i in range(len(articlecommandeefacture)):
			if articlecommandeefacture[i].articleCommandee :
					art = articlecommandeefacture[i].articleCommandee.article.id
					if len(new_liste) > 0 : 
						for j in range(len(new_liste)) :
							if new_liste[j].articleCommandee.article :
								if art == new_liste[j].articleCommandee.article.id  : 
									new_liste[j].qantite = new_liste[j].qantite + articlecommandeefacture[i].qantite
					new_liste.append(articlecommandeefacture[i])			   
			else :
					art = articlecommandeefacture[i].article.id
					if len(new_liste) > 0 : 
						for j in range(len(new_liste)) :
							if new_liste[j].article :
								if art == new_liste[j].article.id  : 
									new_liste[j].qantite = new_liste[j].qantite + articlecommandeefacture[i].qantite
					new_liste.append(articlecommandeefacture[i])			

		paiements = Paiement.objects.all().filter(facture = facture)
		context['articlecommandeefacture'] = new_liste
		context['liste_paiements'] = paiements
		context['profile_organisation'] = Organisation.objects.last()
		listepaiements = Paiement.objects.filter(facture_id = id_facture)
		total_m = 0
		if listepaiements :
			for r in listepaiements :
				total_m = total_m + r.montant
		context['total_m'] = total_m
	
	return render(request, 'afficher-facture.html', context)
@login_required(login_url="/login/")	
def affiche_ajouter_facture(request):
	context = {}
	context['liste_clients'] = Client.objects.filter(status ='actif')
	context['liste_agences'] = Agence.objects.all().values()
	context['liste_entrepots'] = Entrepot.objects.all()
	liste_articles = []
	artilces = Article.objects.all()
	for i in artilces :
		if Lot.objects.all().filter(article = i).exists():
			liste_articles.append(i)

	context['liste_articles'] = liste_articles
	context['liste_conditionsPaiement'] = ConditionPaiement.objects.all().values()
	context['liste_villes'] = Ville.objects.all().values()

	user = request.POST.get('user')
	operatrice = User.objects.get(id = user)
	

	return render(request, 'ajouter-facture.html', context)



@login_required(login_url="/login/")
def ajouter_facture_non_commandee(request):
	context = {}

	if request.method == "POST":

		article = request.POST.getlist('article_options[]')
		lot = request.POST.getlist('lots_options[]')
		qantite = request.POST.getlist('qantite_options[]')
		taux = request.POST.getlist('taux_options[]')
		remise = request.POST.getlist('remise_options[]')
		taxe = request.POST.getlist('taxe_options[]')
		montant = request.POST.getlist('montant_options[]')
		total_f = request.POST.get('total')
		description = request.POST.getlist('description_options[]')	




		if len(article) > 0   :
			form = FactureForm(request.POST or None)
			print('isn t valid')
			if form.is_valid():
				print("is valid")
				form.save()
				last_facture = Facture.objects.last().id
				facture = Facture.objects.get(id = last_facture)
				Facture.objects.filter(id = last_facture).update(status = "BROUILLON")
				Facture.objects.filter(id = last_facture).update(reste = total_f)
				Facture.objects.filter(id = last_facture).update(expiditions = "Non expedie")


				for i in range(len(qantite)):
					lot_id = lot[i].split()[0]
					lot_obj = Lot.objects.get(id=lot_id)
					article_id = article[i].split()[0]
					articel_fact = Article.objects.get(id = article_id)

					lot_quantite = lot_obj.quantitee
					qt = lot_quantite
					if lot_quantite > 0 and decimal.Decimal(qantite[i]) > lot_quantite :
						articlecommandeefacture = Articlescommandeefactures(facture = facture ,lot = lot_obj,qantite=lot_quantite, taxe=taxe[i]  ,remise = remise[i] ,montant =montant[i] ,taux =taux[i] ,article =  articel_fact)
						articlecommandeefacture.save()

						while qt < decimal.Decimal(qantite[i]) : 
								dif_qt =decimal.Decimal(qantite[i]) - qt
								new_lot = Lot.objects.filter(article = articel_fact).order_by('created_at').exclude(quantitee=0) 				
								second_lot = new_lot[1]
								if second_lot.quantitee >= dif_qt :
									qt = qt + dif_qt
									new_articlefacture = Articlescommandeefactures(facture = facture ,article = articel_fact , lot = second_lot,qantite= dif_qt )
									new_articlefacture.save()
										
								elif second_lot.quantitee < dif_qt :
									qt = qt + new_lot.quantitee  
									new_articlefacture = Articlescommandeefactures(facture = facture ,article = articel_fact , lot = new_lot,qantite= new_lot.quantitee)
									new_articlefacture.save()
					else :	
						articlecommandeefacture = Articlescommandeefactures(facture = facture ,  lot = lot_obj,qantite=qantite[i] , taxe=taxe[i] ,remise = remise[i] ,montant =montant[i] ,taux =taux[i] ,article=articel_fact)
						articlecommandeefacture.save() 
					

				messages.success(request, 'facture a été bien ajouté')	
			else :
				messages.error(request, form_validation_error(form))
		else :
				messages.error(request, 'Aucun article  n’existe')
				return redirect('affiche_ajouter_facture')		

	return redirect('liste_facture')
@login_required(login_url="/login/")	
def marquer_comme_envoye(request):
    context = {}
    if request.method == "POST":
    	id_facture = request.POST.get('id_facture')
    	num_facture = request.POST.get('num_facture')

    	facture = Facture.objects.get(id = id_facture)
    	articlecommandeefacture = Articlescommandeefactures.objects.filter(facture=facture)
    	if facture.commande :
    		commande = Commande.objects.get(id = facture.commande.id)
    	if facture.status == 'BROUILLON' :
    		Facture.objects.filter(id = id_facture).update(status = "Envoyee")
    		Facture.objects.filter(id = id_facture).update(num_facture = num_facture)

    		for i in range(len(articlecommandeefacture)) :
    			if  articlecommandeefacture[i].articleCommandee :
    					artic = Article.objects.get(id = articlecommandeefacture[i].articleCommandee.article.id)
    					new_stock_comptable_engage = artic.stock_comptable_engage - articlecommandeefacture[i].qantite
    					new_stock_comptable_disponible = artic.stock_comptable_disponible - articlecommandeefacture[i].qantite
    					Article.objects.filter(id = articlecommandeefacture[i].articleCommandee.article.id).update(stock_comptable_engage = new_stock_comptable_engage)
    					Article.objects.filter(id = articlecommandeefacture[i].articleCommandee.article.id).update(stock_comptable_disponible = new_stock_comptable_disponible)

    			else :
    					artic = Article.objects.get(id = articlecommandeefacture[i].article.id)
    					new_stock_comptable_disponible_a_la_vente = artic.stock_comptable_disponible_a_la_vente - articlecommandeefacture[i].qantite
    					new_stock_comptable_disponible = artic.stock_comptable_disponible - articlecommandeefacture[i].qantite
    					Article.objects.filter(id = articlecommandeefacture[i].article.id).update(stock_comptable_disponible_a_la_vente = new_stock_comptable_disponible_a_la_vente)
    					Article.objects.filter(id = articlecommandeefacture[i].article.id).update(stock_comptable_disponible = new_stock_comptable_disponible)

    		messages.success(request, 'facture a été envoye')
    	else:
    		messages.info(request, 'facture a été deja envoyé')

    return redirect('liste_facture')
@login_required(login_url="/login/")
def marquer_comme_expedie(request):
	context ={}
	if request.method == "POST":
		id_facture = request.POST.get('id_facture')
		facture = Facture.objects.get(id = id_facture)
		articlecommandeefacture = Articlescommandeefactures.objects.all().filter(facture=facture)
		if facture.status != 'BROUILLON' and facture.expiditions =='Non expedie':
			for i in range(len(articlecommandeefacture)) :
				if not articlecommandeefacture[i].articleCommandee :
						artic = Article.objects.get(id = articlecommandeefacture[i].article.id)
						new_stock_physique_disponible_a_la_vente = artic.stock_physique_disponible_a_la_vente - articlecommandeefacture[i].qantite
						new_stock_physique_disponible = artic.stock_physique_disponible - articlecommandeefacture[i].qantite
						Article.objects.filter(id = articlecommandeefacture[i].article.id).update(stock_physique_disponible_a_la_vente = new_stock_physique_disponible_a_la_vente)
						Article.objects.filter(id = articlecommandeefacture[i].article.id).update(stock_physique_disponible = new_stock_physique_disponible)
						lotexp = articlecommandeefacture[i].lot.id
						lotExped = Lot.objects.get(id = lotexp)
						new_qantite_lot = lotExped.quantitee - articlecommandeefacture[i].qantite
						Lot.objects.filter(id = lotexp).update(quantitee = new_qantite_lot)
					
			
			Facture.objects.filter(id = id_facture).update(expiditions = "expedie")
			messages.success(request, 'facture a été marquer comme expedie')


	return redirect('liste_facture')


@login_required(login_url="/login/")
def ajouter_facture_fournisseur(request):
	context = {}
	context['segment'] = 'commandes'
	context['liste_commandes'] = Commande.objects.all()
	if request.method == "POST":

		articleCommande = request.POST.getlist('article_options[]')
		qantite = request.POST.getlist('qantite_options[]')
		taux = request.POST.getlist('taux_options[]')
		taxe = request.POST.getlist('taxe_options[]')
		montant = request.POST.getlist('montant_options[]')		
		total_f = request.POST.get('total')

	

		form = FactureForm(request.POST or None)
		if form.is_valid():
			print("is valid")
			form.save()
			last_facture = Facture.objects.last().id
			facture = Facture.objects.get(id = last_facture)

			Facture.objects.filter(id = last_facture).update(status = "BROUILLON")
			Facture.objects.filter(id = last_facture).update(reste = total_f) 
			for i in range(len(qantite)):
				articlecommande = ArticleCommandee.objects.get( id = articleCommande[i])
				if articlecommande.qantite_reste >= decimal.Decimal(qantite[i]) :
					if 	articlecommande.qantite_reste != 0 :	
						articlecommandeefacture = Articlescommandeefactures(facture = facture , articleCommandee = articlecommande,qantite=qantite[i] , taxe=taxe[i]  ,montant =montant[i] ,taux =taux[i] )
						articlecommandeefacture.save()	
						
						qant = articlecommande.facturee + decimal.Decimal(qantite[i])
						ArticleCommandee.objects.filter(id = articleCommande[i]).update(facturee = qant)
						
						qt_r = articlecommande.qantite_total - qant
						montant_reste = qt_r  * articlecommande.taux
						if decimal.Decimal(taxe[i]) > 0 :
							montant_reste = (montant_reste *  articlecommande.taxe ) / 100
						
						ArticleCommandee.objects.filter(id = articleCommande[i]).update(qantite_reste = qt_r)
						ArticleCommandee.objects.filter(id = articleCommande[i]).update(montant_reste = montant_reste)
			

			id_commande = request.POST.get('commande')
			commande = Commande.objects.get(id = id_commande)
			artclecom = ArticleCommandee.objects.filter(commande=commande)
			qantite_reste = 0
			for a in artclecom : 
				qantite_reste = qantite_reste + a.qantite_reste 
			if qantite_reste == 0 :
				Commande.objects.filter(id = id_commande).update(facturee = 'facturee')
				if Commande.objects.get(id = id_commande).reçu == 'Reçu':
					Commande.objects.filter(id = id_commande).update(status = 'Fermer')
			else :
				Commande.objects.filter(id = id_commande).update(facturee = 'Partiellement facturee')
			
			messages.success(request, 'facture fournisseur a été bien ajouté')	

	return redirect('liste_bon_commandes')

@login_required(login_url="/login/")
def liste_facture_fournisseur(request):
    context = {}
    context['segment'] = 'factureFournisseur'
    context['liste_facture_fournisseur'] = Facture.objects.all().exclude(fournisseur=None)
    context['now'] = date.today()

    return render(request, 'liste-factures-fournisseur.html', context)


@login_required(login_url="/login/")
def afficher_facture_fournisseur(request):
	context = {}	
	if request.method == "POST":
		id_facture = request.POST.get('id_facture')
		facture = Facture.objects.get(id = id_facture)
		
		articlecommandeefacture = Articlescommandeefactures.objects.all().filter(facture=facture)
		paiements = Paiement.objects.filter(facture = facture)
		listepaiements = Paiement.objects.filter(facture_id = id_facture)
		total_m = 0
		if listepaiements :
			for r in listepaiements :
				total_m = total_m + r.montant
		print(paiements)
		context['facture'] = facture
		context['articlecommandeefacture'] = articlecommandeefacture
		context['liste_paiements_fournisseur'] = paiements
		context['total_m'] = total_m


	return render(request, 'afficher-facture-fournisseur.html', context)


@login_required(login_url="/login/")	
def convertir_en_ouvert(request):
    context = {}
    if request.method == "POST":
    	id_facture = request.POST.get('id_facture')
    	num_facture = request.POST.get('num_facture')
    	facture = Facture.objects.get(id = id_facture)
    	articlecommandeefacture = Articlescommandeefactures.objects.filter(facture=facture)
    	if facture.commande :
    		commande = Commande.objects.get(id = facture.commande.id)
    	if facture.status == 'BROUILLON' :
    		Facture.objects.filter(id = id_facture).update(status = "Ouvert")  		
    		Facture.objects.filter(id = id_facture).update(num_facture = num_facture)
    		for i in range(len(articlecommandeefacture)) :
    			if  articlecommandeefacture[i].articleCommandee :
    					artic = Article.objects.get(id = articlecommandeefacture[i].articleCommandee.article.id)
    					new_stock_comptable_disponible_a_la_vente = artic.stock_comptable_disponible_a_la_vente + articlecommandeefacture[i].qantite
    					new_stock_comptable_disponible = artic.stock_comptable_disponible + articlecommandeefacture[i].qantite
    					new_quantitee_non_declarer_comme_lot = artic.quantitee_non_declarer_comme_lot + articlecommandeefacture[i].qantite
    					Article.objects.filter(id = articlecommandeefacture[i].articleCommandee.article.id).update(stock_comptable_disponible_a_la_vente = new_stock_comptable_disponible_a_la_vente)
    					Article.objects.filter(id = articlecommandeefacture[i].articleCommandee.article.id).update(stock_comptable_disponible = new_stock_comptable_disponible)
    					Article.objects.filter(id = articlecommandeefacture[i].articleCommandee.article.id).update(quantitee_non_declarer_comme_lot = new_quantitee_non_declarer_comme_lot)	

    			else :
    					artic = Article.objects.get(id = articlecommandeefacture[i].article.id)
    					new_stock_comptable_disponible_a_la_vente = artic.stock_comptable_disponible_a_la_vente + articlecommandeefacture[i].qantite
    					new_stock_comptable_disponible = artic.stock_comptable_disponible + articlecommandeefacture[i].qantite
    					new_stock_physique_disponible = artic.stock_physique_disponible + articlecommandeefacture[i].qantite
    					new_stock_physique_disponible_a_la_vente = artic.stock_physique_disponible_a_la_vente + articlecommandeefacture[i].qantite
    					new_quantitee_non_declarer_comme_lot = artic.quantitee_non_declarer_comme_lot + articlecommandeefacture[i].qantite


    					Article.objects.filter(id = articlecommandeefacture[i].article.id).update(stock_comptable_disponible_a_la_vente = new_stock_comptable_disponible_a_la_vente)
    					Article.objects.filter(id = articlecommandeefacture[i].article.id).update(stock_comptable_disponible = new_stock_comptable_disponible)
    					Article.objects.filter(id = articlecommandeefacture[i].article.id).update(quantitee_non_declarer_comme_lot = new_quantitee_non_declarer_comme_lot)
    					Article.objects.filter(id = articlecommandeefacture[i].article.id).update(stock_physique_disponible = new_stock_physique_disponible)
    					Article.objects.filter(id = articlecommandeefacture[i].article.id).update(stock_physique_disponible_a_la_vente = new_stock_physique_disponible_a_la_vente)
    					

    			
    		messages.success(request, 'Le statut de la facture fournisseur a été changé en Ouvert.')
    	else:
    		messages.info(request, 'Le statut de la facture fournisseur a été déja changé en Ouvert')

    return redirect('liste_facture_fournisseur')	



login_required(login_url="/login/")
def ajouter_facture_fournisseur_non_commandee(request):
	context = {}

	if request.method == "POST":

		article = request.POST.getlist('article_options[]')
		qantite = request.POST.getlist('qantite_options[]')
		taux = request.POST.getlist('taux_options[]')
		taxe = request.POST.getlist('taxe_options[]')
		montant = request.POST.getlist('montant_options[]')
		total_f = request.POST.get('total')
		description = request.POST.getlist('description_options[]')	


		form = FactureForm(request.POST or None)
		if form.is_valid():
			print("is valid")
			form.save()
			last_facture = Facture.objects.last().id
			facture = Facture.objects.get(id = last_facture)
			Facture.objects.filter(id = last_facture).update(status = "BROUILLON")
			Facture.objects.filter(id = last_facture).update(reste = total_f)


			for i in range(len(qantite)):
					article_id = article[i].split()[0]
					articel_fact = Article.objects.get(id = article_id)
					articlecommandeefacture = Articlescommandeefactures(facture = facture ,qantite=qantite[i], taxe=taxe[i] ,montant =montant[i] ,taux =taux[i] ,article =  articel_fact)
					articlecommandeefacture.save()


			messages.success(request, 'facture fournisseur a été bien ajouté')	

	return redirect('liste_facture_fournisseur')



@login_required(login_url="/login/")	
def affiche_ajouter_facture_fournisseur(request):
	context = {}
	context['liste_fournisseurs'] = Fournisseur.objects.filter(status = 'actif')
	context['liste_agences'] = Agence.objects.all().values()
	context['liste_entrepots'] = Entrepot.objects.all()
	liste_articles = []
	artilces = Article.objects.all()
	for i in artilces :
		if Lot.objects.all().filter(article = i).exists():
			liste_articles.append(i)
			
	context['liste_articles'] = liste_articles
	context['liste_conditionsPaiement'] = ConditionPaiement.objects.all().values()
	context['liste_villes'] = Ville.objects.all().values()



	return render(request, 'ajouter-facture-fournisseur.html', context)	


@login_required(login_url="/login/")
def afficher_modifier_facture(request):
	context = {}	
	if request.method == "POST":
		id_facture = request.POST.get('id_facture')
		facture = Facture.objects.get(id = id_facture)
		context['facture'] = facture
		articlecommandeefacture = Articlescommandeefactures.objects.filter(facture=facture)

		liste_article = []

	  
		for i in range(len(articlecommandeefacture)):
			if articlecommandeefacture[i].articleCommandee :
				if articlecommandeefacture[i].articleCommandee.article :
						liste_article.append(articlecommandeefacture[i])
   
			

			else :
				if articlecommandeefacture[i].article :
						liste_article.append(articlecommandeefacture[i])			


		paiements = Paiement.objects.filter(facture = facture)
		montant_paye = 0 
		if len(paiements) > 0 :
			for i in range(len(paiements)):
				montant_paye = paiements[i].montant + montant_paye


		context['liste_article'] = liste_article

		context['montant_paye'] = montant_paye
		context['liste_articles'] = Article.objects.all()
		context['liste_conditionsPaiement'] = ConditionPaiement.objects.all().values()


	return render(request, 'modifier-facture.html', context)

@login_required(login_url="/login/")
def valider_modifier_facture(request):
	context = {}	
	if request.method == "POST":
		id_facture = request.POST.get('id_facture')
		facture = Facture.objects.get(id = id_facture)
		date = request.POST.get('date')
		date_echeance = request.POST.get('date_echeance')
		condition_de_paiement = request.POST.get('condition_de_paiement')
		sous_total = request.POST.get('sous_total')
		frais_expedition = request.POST.get('frais_expedition')
		condition_generales = request.POST.get('condition_generales')	
		info_client = request.POST.get('info_client')
		ajustement = request.POST.get('ajustement')
		total = request.POST.get('total')
		num_facture = request.POST.get('num_facture')



		Facture.objects.filter(id = id_facture).update(date = date)
		if date_echeance :
			Facture.objects.filter(id = id_facture).update(date_echeance = date_echeance)
		Facture.objects.filter(id = id_facture).update(condition_de_paiement = condition_de_paiement)
		Facture.objects.filter(id = id_facture).update(condition_generales = condition_generales)
		Facture.objects.filter(id = id_facture).update(info_client = info_client)
		Facture.objects.filter(id = id_facture).update(sous_total = sous_total)
		Facture.objects.filter(id = id_facture).update(frais_expedition = frais_expedition)
		Facture.objects.filter(id = id_facture).update(ajustement = ajustement)
		Facture.objects.filter(id = id_facture).update(total = total)
		Facture.objects.filter(id = id_facture).update(num_facture = num_facture)


		article_commande = request.POST.getlist('article_commande_facture[]')
		qantite = request.POST.getlist('qantite_options[]')
		taux = request.POST.getlist('taux_options[]')
		remise = request.POST.getlist('remise_options[]')
		taxe = request.POST.getlist('taxe_options[]')
		montant = request.POST.getlist('montant_options[]')
		unite_gratuit = request.POST.getlist('unite_gratuit_options[]')
		#description = request.POST.getlist('description_options[]')		



		montant_reste_fact = facture.reste ;

		# modiferi article 
		for i in range(len(article_commande)):
					articlecom = Articlescommandeefactures.objects.get(id = article_commande[i])
					
					if articlecom.articleCommandee :
						articlecommande = ArticleCommandee.objects.get(id = articlecom.articleCommandee.id)
						id_article = articlecom.articleCommandee.article.id 
					else :
						id_article = articlecom.article.id

					art = Article.objects.get(id = id_article)
					print('valide' , decimal.Decimal(qantite[i]) > articlecom.qantite)

					if decimal.Decimal(qantite[i]) > articlecom.qantite :
						qantite_bet = decimal.Decimal(qantite[i]) - articlecom.qantite
						

						if articlecom.articleCommandee :
							qantite_reste = articlecommande.qantite_reste - qantite_bet
							qantite_facture = articlecommande.facturee + qantite_bet
							montant_reste = articlecommande.montant_reste - mantant_nouv
							print('qantite_reste' , qantite_reste)

						mantant_nouv = decimal.Decimal(montant[i]) - articlecom.montant				
						montant_reste_fact = montant_reste_fact + mantant_nouv
						print('montant_reste_fact' ,montant_reste_fact)
						print('mantant_nouv' , mantant_nouv)
						print('qantite_bet' , qantite_bet)



						if facture.status != 'BROUILLON':
							new_stock_comptable_disponible	= art.stock_comptable_disponible  - qantite_bet
							Article.objects.filter(id = id_article).update(stock_comptable_disponible = new_stock_comptable_disponible)
							if facture.commande == None :
								new_stock_comptable_disponible_a_la_vente = art.stock_comptable_disponible_a_la_vente - qantite_bet
								Article.objects.filter(id = id_article).update(stock_comptable_disponible_a_la_vente = new_stock_comptable_disponible_a_la_vente)


		 
					else :
						qantite_bet =  articlecom.qantite - decimal.Decimal(qantite[i] )
						mantant_nouv =  articlecom.montant  - decimal.Decimal(montant[i])
						montant_reste_fact = montant_reste_fact -  mantant_nouv

						if articlecom.articleCommandee :
							qantite_reste = articlecommande.qantite_reste + qantite_bet
							qantite_facture = articlecommande.facturee - qantite_bet
							montant_reste = articlecommande.montant_reste + mantant_nouv


						if facture.status != 'BROUILLON':
							new_stock_comptable_disponible	= art.stock_comptable_disponible  + qantite_bet
							Article.objects.filter(id = id_article).update(stock_comptable_disponible = new_stock_comptable_disponible)
							if facture.commande == None :
								new_stock_comptable_disponible_a_la_vente = art.stock_comptable_disponible_a_la_vente + qantite_bet
								Article.objects.filter(id = id_article).update(stock_comptable_disponible_a_la_vente = new_stock_comptable_disponible_a_la_vente)


					if articlecom.articleCommandee :
						if decimal.Decimal(unite_gratuit[i]) > articlecom.unite_gratuit :
							ug_nouv = decimal.Decimal(unite_gratuit[i]) - articlecom.unite_gratuit 
							unite_gratuit_reste = articlecommande.unite_gratuit_reste - ug_nouv		
						else :
							ug_nouv =  articlecom.unite_gratuit - decimal.Decimal(unite_gratuit[i] )
							unite_gratuit_reste = articlecommande.unite_gratuit_reste + ug_nouv


					Articlescommandeefactures.objects.filter(id = article_commande[i]).update(qantite = qantite[i])
					Articlescommandeefactures.objects.filter(id = article_commande[i]).update(taxe = taxe[i])
					Articlescommandeefactures.objects.filter(id = article_commande[i]).update(montant = montant[i])
					#Articlescommandeefactures.objects.filter(id = article_commande[i]).update(description = description[i])
					Articlescommandeefactures.objects.filter(id = article_commande[i]).update(remise = remise[i])
					Articlescommandeefactures.objects.filter(id = article_commande[i]).update(taux = taux[i])
					Articlescommandeefactures.objects.filter(id = article_commande[i]).update(unite_gratuit = unite_gratuit[i])
					
					if articlecom.articleCommandee :
						ArticleCommandee.objects.filter(id = articlecom.articleCommandee.id).update(qantite_reste = qantite_reste)
						ArticleCommandee.objects.filter(id = articlecom.articleCommandee.id).update(montant_reste = montant_reste)
						ArticleCommandee.objects.filter(id = articlecom.articleCommandee.id).update(unite_gratuit_reste = unite_gratuit_reste)
						ArticleCommandee.objects.filter(id = articlecom.articleCommandee.id).update(facturee = qantite_facture)

		# ADD NEW ARTICLE
		article_new = request.POST.getlist('article_options_new[]')
		if len(article_new) > 0 :
			lot_new = request.POST.getlist('lots_options_new[]')
			qantite_new = request.POST.getlist('qantite_options_new[]')
			ug_new = request.POST.getlist('unite_gratuit_options_new[]')
			taux_new = request.POST.getlist('taux_options_new[]')
			remise_new = request.POST.getlist('remise_options_new[]')
			taxe_new = request.POST.getlist('taxe_options_new[]')
			montant_new = request.POST.getlist('montant_options_new[]')
			description_new = request.POST.getlist('description_options_new[]')
			for i in range(len(article_new)):
					id_article = article_new[i].split()[0]
					articleobj = Article.objects.get(id=id_article)
					id_lot = lot_new[i].split()[0]
					lot_obj = Lot.objects.get(id=id_lot)
					montant_reste_fact = montant_reste_fact +  decimal.Decimal(montant_new[i]) 
					lot_quantite = lot_obj.quantitee
					qt = lot_quantite
					if lot_quantite > 0 and decimal.Decimal(qantite_new[i]) > lot_quantite :
						articlecommandeefacture = Articlescommandeefactures(facture = facture ,lot = lot_obj,qantite=lot_quantite, taxe=taxe_new[i] , unite_gratuit = ug_new[i]  ,remise = remise_new[i] ,montant =montant[i] ,taux =taux_new[i] ,article =  articleobj , description = description_new[i] )
						articlecommandeefacture.save()

						while qt < decimal.Decimal(qantite_new[i]) : 
								dif_qt =decimal.Decimal(qantite_new[i]) - qt
								new_lot = Lot.objects.filter(article = articleobj).order_by('created_at').exclude(quantitee=0) 				
								second_lot = new_lot[1]
								if second_lot.quantitee >= dif_qt :
									qt = qt + dif_qt
									new_articlefacture = Articlescommandeefactures(facture = facture ,article = articleobj , lot = second_lot,qantite= dif_qt )
									new_articlefacture.save()
										
								elif second_lot.quantitee < dif_qt :
									qt = qt + new_lot.quantitee  
									new_articlefacture = Articlescommandeefactures(facture = facture ,article = articleobj , lot = new_lot,qantite= new_lot.quantitee)
									new_articlefacture.save()
					else :	
						articlescommandeefactures = Articlescommandeefactures(facture = facture ,article = articleobj , lot = lot_obj,qantite =qantite_new[i] , taxe=taxe_new[i] , unite_gratuit = ug_new[i]  ,remise = remise_new[i] ,montant =montant_new[i]  , description = description_new[i] , taux = taux_new[i])
						articlescommandeefactures.save()
						
					if facture.status != 'BROUILLON' :
						new_stock_comptable_disponible_a_la_vente = articleobj.stock_comptable_disponible_a_la_vente - decimal.Decimal(qantite_new[i])
						new_stock_comptable_disponible = articleobj.stock_comptable_disponible - decimal.Decimal(qantite_new[i])
						Article.objects.filter(id = id_article).update(stock_comptable_disponible_a_la_vente = new_stock_comptable_disponible_a_la_vente)
						Article.objects.filter(id = id_article).update(stock_comptable_disponible = new_stock_comptable_disponible)

		# Supp ARTICLE Commande 				
		liste_art_supp = request.POST.getlist('article_commande_supprimer[]')	
		print('liste art ',liste_art_supp)
		if liste_art_supp[0] != '' :

			for i in range(len(liste_art_supp)):
						articlC = Articlescommandeefactures.objects.get(id = liste_art_supp[i])			
						if articlC.articleCommandee :
								articlecommandee = ArticleCommandee.objects.get(id = articlC.articleCommandee.id)
								qntite_new_reste = articlecommandee.qantite_reste + articlC.qantite
								mantant_new_reste = articlecommandee.montant_reste + articlC.montant
								unite_gratuit_new_reste = articlecommandee.unite_gratuit + articlC.unite_gratuit
								qantitefacture = articlecommandee.facturee - articlC.qantite
								ArticleCommandee.objects.filter(id = articlecommandee.id).update(montant_reste = mantant_new_reste)
								ArticleCommandee.objects.filter(id = articlecommandee.id).update(qantite_reste = qntite_new_reste)
								ArticleCommandee.objects.filter(id = articlecommandee.id).update(unite_gratuit = unite_gratuit_new_reste)
								ArticleCommandee.objects.filter(id = articlecommandee.id).update(facturee = qantitefacture)
							
								if facture.status != 'BROUILLON':
									art = Article.objects.get(id = articlC.articleCommandee.article.id) 
									new_stock_comptable_disponible	= art.stock_comptable_disponible  + articlC.qantite
									new_stock_comptable_engage = art.stock_comptable_engage + articlC.qantite
									Article.objects.filter(id = art.id).update(stock_comptable_disponible = new_stock_comptable_disponible)
									Article.objects.filter(id = art.id).update(stock_comptable_engage = new_stock_comptable_engage)
						else : 
								if facture.status != 'BROUILLON' :
									art = Article.objects.get(id = articlC.article.id) 
									new_stock_comptable_engage	= art.stock_comptable_disponible  + articlC.qantite
									Article.objects.filter(id = art.id).update(stock_comptable_disponible = new_stock_comptable_engage)
									new_stock_comptable_disponible_a_la_vente = art.stock_comptable_disponible_a_la_vente + articlC.qantite
									Article.objects.filter(id = art.id).update(stock_comptable_disponible_a_la_vente = new_stock_comptable_disponible_a_la_vente)
						
						montant_reste_fact = montant_reste_fact -  articlC.montant
						articlC.delete()



		Facture.objects.filter(id = id_facture).update(reste = montant_reste_fact)
		if  montant_reste_fact == Facture.objects.get(id = id_facture).total :
			if  facture.status == 'Envoyee' or facture.status == 'Paye' or facture.status == 'Partiellement payee' :
				Facture.objects.filter(id =id_facture).update(status = "Envoyee")
			else :
				Facture.objects.filter(id =id_facture).update(status = "BROUILLON")
		elif montant_reste_fact == 0 :
			Facture.objects.filter(id = id_facture).update(status = "Paye")
		elif montant_reste_fact < Facture.objects.get(id = id_facture).total :
			Facture.objects.filter(id =id_facture).update(status = "Partiellement payee")
		

		if facture.commande :
				list_facture = Facture.objects.filter(commande = facture.commande)
				artclecom = ArticleCommandee.objects.filter(commande= facture.commande)
				reste_facture = 0
				montant_fact = 0
				qantite_reste = 0
				quantite_totaly = 0

				if list_facture :
					for fa in list_facture :
						reste_facture  = fa.reste + reste_facture
						montant_fact = fa.total +  montant_fact
				
				for a in artclecom : 
					qantite_reste = qantite_reste + a.qantite_reste
					quantite_totaly  = quantite_totaly + a.qantite_total
				
				if qantite_reste == quantite_totaly  :
					Commande.objects.filter(id = commande.id ).update(facturee = 'Non facture')
					Commande.objects.filter(id = commande.id).update(status = 'CONFIRMEE')
				elif qantite_reste == 0 :
					 Commande.objects.filter(id = commande.id).update(facturee = 'facturee')
					 Commande.objects.filter(id = commande.id).update(status = 'FERME')
				elif qantite_reste < quantite_totaly :
					 Commande.objects.filter(id = commande.id).update(facturee = 'Partiellement facturee')
					 Commande.objects.filter(id = commande.id).update(status = 'CONFIRMEE')
				
				if reste_facture == montant_fact :
						Commande.objects.filter(id = commande.id).update(paiement = 'Impaye')
				elif reste_facture == 0 :
					 if Commande.objects.get(id = commande.id).facturee == 'facturee' :
					 	Commande.objects.filter(id = commande.id).update(paiement = 'Paye')
					 else :
					 	Commande.objects.filter(id =commande.id).update(paiement ='Partiellement payee')	 	
				elif reste_facture < montant_fact :
					 Commande.objects.filter(id = commande.id).update(paiement = 'Partiellement payee')
							
		print(facture)
		
	
	return redirect('liste_facture')

@login_required(login_url="/login/")
def supprimer_facture(request):

	if request.method == "POST":
		id_facture = request.POST.get('id_facture')
		facture = Facture.objects.get(id = id_facture)
		articlescommandeefactures = Articlescommandeefactures.objects.filter(facture = facture)


		if facture.status == 'BROUILLON' or facture.status == 'Envoyee' :
				if facture.status == 'Envoyee' :		
					for i in range(len(articlescommandeefactures)) :
						if articlescommandeefactures[i].articleCommandee :
							articlecommandee = ArticleCommandee.objects.get(id = articlescommandeefactures[i].articleCommandee.id)

							qntite_new_reste = articlecommandee.qantite_reste + articlescommandeefactures[i].qantite
							mantant_new_reste = articlecommandee.montant_reste + articlescommandeefactures[i].montant
							unite_gratuit_new_reste = articlecommandee.unite_gratuit + articlescommandeefactures[i].unite_gratuit
							qantitefacture = articlecommandee.facturee - articlescommandeefactures[i].qantite

							ArticleCommandee.objects.filter(id = articlecommandee.id).update(montant_reste = mantant_new_reste)
							ArticleCommandee.objects.filter(id = articlecommandee.id).update(qantite_reste = qntite_new_reste)
							ArticleCommandee.objects.filter(id = articlecommandee.id).update(unite_gratuit = unite_gratuit_new_reste)
							ArticleCommandee.objects.filter(id = articlecommandee.id).update(facturee = qantitefacture)


							if articlescommandeefactures[i].articleCommandee.article: 
								id_art = articlescommandeefactures[i].articleCommandee.article.id
								art = Article.objects.get(id = id_art) 
								new_stock_comptable_disponible	= art.stock_comptable_disponible  + articlescommandeefactures[i].qantite
								new_stock_comptable_engage = art.stock_comptable_engage + articlescommandeefactures[i].qantite
								Article.objects.filter(id = art.id).update(stock_comptable_disponible = new_stock_comptable_disponible)
								Article.objects.filter(id = art.id).update(stock_comptable_engage = new_stock_comptable_engage)
								
	
						else : 
							if articlescommandeefactures[i].article: 
								id_art = articlescommandeefactures[i].article.id
								art = Article.objects.get(id = id_art) 
								new_stock_comptable_engage	= art.stock_comptable_disponible  + articlescommandeefactures[i].qantite
								Article.objects.filter(id = art.id).update(stock_comptable_disponible = new_stock_comptable_engage)
								new_stock_comptable_disponible_a_la_vente = art.stock_comptable_disponible_a_la_vente + articlescommandeefactures[i].qantite
								Article.objects.filter(id = art.id).update(stock_comptable_disponible_a_la_vente = new_stock_comptable_disponible_a_la_vente)

				else :
					for i in range(len(articlescommandeefactures)) :
						if articlescommandeefactures[i].articleCommandee :
							articlecommandee = ArticleCommandee.objects.get(id = articlescommandeefactures[i].articleCommandee.id)

							qntite_new_reste = articlecommandee.qantite_reste + articlescommandeefactures[i].qantite
							mantant_new_reste = articlecommandee.montant_reste + articlescommandeefactures[i].montant
							unite_gratuit_new_reste = articlecommandee.unite_gratuit + articlescommandeefactures[i].unite_gratuit
							qantitefacture = articlecommandee.facturee - articlescommandeefactures[i].qantite


							ArticleCommandee.objects.filter(id = articlecommandee.id).update(montant_reste = mantant_new_reste)
							ArticleCommandee.objects.filter(id = articlecommandee.id).update(qantite_reste = qntite_new_reste)
							ArticleCommandee.objects.filter(id = articlecommandee.id).update(unite_gratuit = unite_gratuit_new_reste)
							ArticleCommandee.objects.filter(id = articlecommandee.id).update(facturee = qantitefacture)



				
				if  facture.commande :
					commande = Commande.objects.get(id = facture.commande.id)
					list_facture = Facture.objects.filter(commande = commande)
					artclecom = ArticleCommandee.objects.filter(commande=commande)
					reste_facture = 0
					montant_fact = 0
					qantite_reste = 0
					quantite_totaly = 0

					if list_facture :
						for fa in list_facture :
							reste_facture  = fa.reste + reste_facture
							montant_fact = fa.total +  montant_fact
					
					for a in artclecom : 
						qantite_reste = qantite_reste + a.qantite_reste
						quantite_totaly  = quantite_totaly + a.qantite_total
					
					if qantite_reste == quantite_totaly  :
						Commande.objects.filter(id = commande.id ).update(facturee = 'Non facture')
						Commande.objects.filter(id = commande.id).update(status = 'CONFIRMEE')
					elif qantite_reste == 0 :
						 Commande.objects.filter(id = commande.id).update(facturee = 'facturee')
						 Commande.objects.filter(id = commande.id).update(status = 'FERME')
					elif qantite_reste < quantite_totaly :
						 Commande.objects.filter(id = commande.id).update(facturee = 'Partiellement facturee')
						 Commande.objects.filter(id = commande.id).update(status = 'CONFIRMEE')
					
					if reste_facture == montant_fact :
							Commande.objects.filter(id = commande.id).update(paiement = 'Impaye')
					elif reste_facture == 0 :
						 if Commande.objects.get(id = commande.id).facturee == 'facturee' :
						 	Commande.objects.filter(id = commande.id).update(paiement = 'Paye')
						 else :
						 	Commande.objects.filter(id =commande.id).update(paiement ='Partiellement payee')	 	
					elif reste_facture < montant_fact :
						 Commande.objects.filter(id = commande.id).update(paiement = 'Partiellement payee')
				
				facture.delete()
				messages.info(request , 'facture bien supprimé')			
		else :
			messages.info(request, 'Ce contact ne peut pas être supprimé car il est associé à des transactions ou des documents')

	return redirect('liste_facture')



@login_required(login_url="/login/")
def afficher_modifier_facture_fournisseur(request):
	context = {}	
	if request.method == "POST":
		id_facture = request.POST.get('id_facture')
		facture = Facture.objects.get(id = id_facture)
		articlecommandeefacture = Articlescommandeefactures.objects.filter(facture=facture)
		paiements = Paiement.objects.filter(facture = facture)
		montant_paye = 0 
		if len(paiements) > 0 :
			for i in range(len(paiements)):
				montant_paye = paiements[i].montant + montant_paye
		context['facture'] = facture
		context['montant_paye'] = montant_paye
		context['articlecommandeefacture'] = articlecommandeefacture
		context['liste_conditionsPaiement'] = ConditionPaiement.objects.all().values()
		context['liste_articles'] = Article.objects.all()

	return render(request, 'modifier-facture-fournisseur.html', context)





@login_required(login_url="/login/")
def valider_modifier_facture_fournisseur(request):
	context = {}	
	if request.method == "POST":
		id_facture = request.POST.get('id_facture')
		facture = Facture.objects.get(id = id_facture)
		date = request.POST.get('date')
		date_echeance = request.POST.get('date_echeance')
		condition_de_paiement = request.POST.get('condition_de_paiement')
		sous_total = request.POST.get('sous_total')
		remise_bn_commande = request.POST.get('remise_bn_commande')
		condition_generales = request.POST.get('condition_generales')	
		info_client = request.POST.get('info_client')
		ajustement = request.POST.get('ajustement')
		total = request.POST.get('total')
		num_facture = request.POST.get('num_facture')



		Facture.objects.filter(id = id_facture).update(date = date)
		if date_echeance :
			Facture.objects.filter(id = id_facture).update(date_echeance = date_echeance)
		Facture.objects.filter(id = id_facture).update(condition_de_paiement = condition_de_paiement)
		Facture.objects.filter(id = id_facture).update(condition_generales = condition_generales)
		Facture.objects.filter(id = id_facture).update(info_client = info_client)
		Facture.objects.filter(id = id_facture).update(sous_total = sous_total)
		Facture.objects.filter(id = id_facture).update(remise_bn_commande = remise_bn_commande)
		Facture.objects.filter(id = id_facture).update(ajustement = ajustement)
		Facture.objects.filter(id = id_facture).update(total = total)
		Facture.objects.filter(id = id_facture).update(num_facture = num_facture)


		article_commande = request.POST.getlist('article_commande_facture[]')
		qantite = request.POST.getlist('qantite_options[]')
		taux = request.POST.getlist('taux_options[]')
		taxe = request.POST.getlist('taxe_options[]')
		montant = request.POST.getlist('montant_options[]')
		montant_reste_fact = facture.reste 

		# modiferi article 
		for i in range(len(article_commande)):
					articlecom = Articlescommandeefactures.objects.get(id = article_commande[i])
					
					if articlecom.articleCommandee :
						articlecommande = ArticleCommandee.objects.get(id = articlecom.articleCommandee.id)
						id_article = articlecom.articleCommandee.article.id 
					else :
						id_article = articlecom.article.id

					art = Article.objects.get(id = id_article)

					if decimal.Decimal(qantite[i]) > articlecom.qantite :
						qantite_bet = decimal.Decimal(qantite[i]) - articlecom.qantite
						mantant_nouv = decimal.Decimal(montant[i]) - articlecom.montant				
						if articlecom.articleCommandee :
							qantite_reste = articlecommande.qantite_reste - qantite_bet
							qantite_facture = articlecommande.facturee + qantite_bet
							montant_reste = articlecommande.montant_reste - mantant_nouv


						
						montant_reste_fact = montant_reste_fact + mantant_nouv


						if facture.status != 'BROUILLON':
			    				new_stock_comptable_disponible_a_la_vente = art.stock_comptable_disponible_a_la_vente +  qantite_bet
			    				new_stock_comptable_disponible = art.stock_comptable_disponible + qantite_bet
			    				new_quantitee_non_declarer_comme_lot = art.quantitee_non_declarer_comme_lot + qantite_bet
			    				Article.objects.filter(id = art.id).update(stock_comptable_disponible_a_la_vente = new_stock_comptable_disponible_a_la_vente)
			    				Article.objects.filter(id = art.id).update(stock_comptable_disponible = new_stock_comptable_disponible)
			    				Article.objects.filter(id = art.id).update(quantitee_non_declarer_comme_lot = new_quantitee_non_declarer_comme_lot)	

			    		
			    				if facture.commande == None :
			    					new_stock_physique_disponible = art.stock_physique_disponible + qantite_bet
			    					new_stock_physique_disponible_a_la_vente = art.stock_physique_disponible_a_la_vente + qantite_bet

			    					Article.objects.filter(id = art.id).update(stock_physique_disponible = new_stock_physique_disponible)
			    					Article.objects.filter(id =art.id).update(stock_physique_disponible_a_la_vente = new_stock_physique_disponible_a_la_vente)
								



					else :
						qantite_bet =  articlecom.qantite - decimal.Decimal(qantite[i] )
						mantant_nouv =  articlecom.montant  - decimal.Decimal(montant[i])
						montant_reste_fact = montant_reste_fact -  mantant_nouv

						if articlecom.articleCommandee :
							qantite_reste = articlecommande.qantite_reste + qantite_bet
							qantite_facture = articlecommande.facturee - qantite_bet
							montant_reste = articlecommande.montant_reste + mantant_nouv


						if facture.status != 'BROUILLON':
								new_stock_comptable_disponible_a_la_vente = art.stock_comptable_disponible_a_la_vente -  qantite_bet
								new_stock_comptable_disponible = art.stock_comptable_disponible - qantite_bet
								new_quantitee_non_declarer_comme_lot = art.quantitee_non_declarer_comme_lot - qantite_bet
								Article.objects.filter(id = art.id).update(stock_comptable_disponible_a_la_vente = new_stock_comptable_disponible_a_la_vente)
								Article.objects.filter(id = art.id).update(stock_comptable_disponible = new_stock_comptable_disponible)
								Article.objects.filter(id = art.id).update(quantitee_non_declarer_comme_lot = new_quantitee_non_declarer_comme_lot)	

								if facture.commande == None :
									new_stock_physique_disponible = art.stock_physique_disponible - qantite_bet
									new_stock_physique_disponible_a_la_vente = art.stock_physique_disponible_a_la_vente - qantite_bet

									Article.objects.filter(id = art.id).update(stock_physique_disponible = new_stock_physique_disponible)
									Article.objects.filter(id =art.id).update(stock_physique_disponible_a_la_vente = new_stock_physique_disponible_a_la_vente)
								


					Articlescommandeefactures.objects.filter(id = article_commande[i]).update(qantite = qantite[i])
					Articlescommandeefactures.objects.filter(id = article_commande[i]).update(taxe = taxe[i])
					Articlescommandeefactures.objects.filter(id = article_commande[i]).update(montant = montant[i])
					Articlescommandeefactures.objects.filter(id = article_commande[i]).update(taux = taux[i])
					
					if articlecom.articleCommandee :
						ArticleCommandee.objects.filter(id = articlecom.articleCommandee.id).update(qantite_reste = qantite_reste)
						ArticleCommandee.objects.filter(id = articlecom.articleCommandee.id).update(montant_reste = montant_reste)
						ArticleCommandee.objects.filter(id = articlecom.articleCommandee.id).update(facturee = qantite_facture)

		
		# ADD NEW ARTICLE
		article_new = request.POST.getlist('article_options_new[]')
		if len(article_new) > 0 :
			qantite_new = request.POST.getlist('qantite_options_new[]')
			taux_new = request.POST.getlist('taux_options_new[]')
			taxe_new = request.POST.getlist('taxe_options_new[]')
			montant_new = request.POST.getlist('montant_options_new[]')
			description_new = request.POST.getlist('description_options_new[]')
			for i in range(len(article_new)):
					id_article = article_new[i].split()[0]
					articleobj = Article.objects.get(id=id_article)
					montant_reste_fact = montant_reste_fact +  decimal.Decimal(montant_new[i]) 
					articlecommandeefacture = Articlescommandeefactures(facture = facture ,qantite=qantite[i], taxe=taxe[i] ,montant =montant[i] ,taux =taux[i] ,article =  articel_fact)
					articlecommandeefacture.save()

						
					if facture.status != 'BROUILLON' :
								new_stock_comptable_disponible_a_la_vente = articleobj.stock_comptable_disponible_a_la_vente +  qantite_bet
								new_stock_comptable_disponible = articleobj.stock_comptable_disponible + qantite_bet
								new_quantitee_non_declarer_comme_lot = articleobj.quantitee_non_declarer_comme_lot + qantite_bet
								Article.objects.filter(id = articleobj.id).update(stock_comptable_disponible_a_la_vente = new_stock_comptable_disponible_a_la_vente)
								Article.objects.filter(id = articleobj.id).update(stock_comptable_disponible = new_stock_comptable_disponible)
								Article.objects.filter(id = articleobj.id).update(quantitee_non_declarer_comme_lot = new_quantitee_non_declarer_comme_lot)	

						
								if facture.commande == None :
									new_stock_physique_disponible = articleobj.stock_physique_disponible + qantite_bet
									new_stock_physique_disponible_a_la_vente = articleobj.stock_physique_disponible_a_la_vente + qantite_bet

									Article.objects.filter(id = articleobj.id).update(stock_physique_disponible = new_stock_physique_disponible)
				
									Article.objects.filter(id =articleobj.id).update(stock_physique_disponible_a_la_vente = new_stock_physique_disponible_a_la_vente)
								
    	
		# Supp ARTICLE Commande 				
		liste_art_supp = request.POST.getlist('article_commande_supprimer[]')	
		print('liste art ',liste_art_supp)
		if liste_art_supp[0] != '' :

			for i in range(len(liste_art_supp)):
						articlC = Articlescommandeefactures.objects.get(id = liste_art_supp[i])			
						if articlC.articleCommandee :
								articlecommandee = ArticleCommandee.objects.get(id = articlC.articleCommandee.id)
								qntite_new_reste = articlecommandee.qantite_reste + articlC.qantite
								mantant_new_reste = articlecommandee.montant_reste + articlC.montant
								qantitefacture = articlecommandee.facturee - articlC.qantite
								ArticleCommandee.objects.filter(id = articlecommandee.id).update(montant_reste = mantant_new_reste)
								ArticleCommandee.objects.filter(id = articlecommandee.id).update(qantite_reste = qntite_new_reste)
								ArticleCommandee.objects.filter(id = articlecommandee.id).update(facturee = qantitefacture)
							
								if facture.status != 'BROUILLON':
									art = Article.objects.get(id = articlC.articleCommandee.article.id) 
									new_stock_comptable_disponible_a_la_vente = art.stock_comptable_disponible_a_la_vente -  articlC.qantite
									new_stock_comptable_disponible = art.stock_comptable_disponible - articlC.qantite
									new_quantitee_non_declarer_comme_lot = art.quantitee_non_declarer_comme_lot - articlC.qantite
									Article.objects.filter(id = art.id).update(stock_comptable_disponible_a_la_vente = new_stock_comptable_disponible_a_la_vente)
									Article.objects.filter(id = art.id).update(stock_comptable_disponible = new_stock_comptable_disponible)
									Article.objects.filter(id = art.id).update(quantitee_non_declarer_comme_lot = new_quantitee_non_declarer_comme_lot)
						else : 
								if facture.status != 'BROUILLON' :
									art = Article.objects.get(id = articlC.article.id) 
									new_stock_comptable_disponible_a_la_vente = art.stock_comptable_disponible_a_la_vente -  articlC.qantite
									new_stock_comptable_disponible = art.stock_comptable_disponible - articlC.qantite
									new_quantitee_non_declarer_comme_lot = art.quantitee_non_declarer_comme_lot - articlC.qantite
									Article.objects.filter(id = art.id).update(stock_comptable_disponible_a_la_vente = new_stock_comptable_disponible_a_la_vente)
									Article.objects.filter(id = art.id).update(stock_comptable_disponible = new_stock_comptable_disponible)
									Article.objects.filter(id = art.id).update(quantitee_non_declarer_comme_lot = new_quantitee_non_declarer_comme_lot)
									new_stock_physique_disponible = art.stock_physique_disponible - qantite_bet
									new_stock_physique_disponible_a_la_vente = art.stock_physique_disponible_a_la_vente - qantite_bet

									Article.objects.filter(id = art.id).update(stock_physique_disponible = new_stock_physique_disponible)
									Article.objects.filter(id =art.id).update(stock_physique_disponible_a_la_vente = new_stock_physique_disponible_a_la_vente)	
						
						montant_reste_fact = montant_reste_fact -  articlC.montant
						articlC.delete()

	
		Facture.objects.filter(id = id_facture).update(reste = montant_reste_fact)
		
		if  montant_reste_fact == Facture.objects.get(id = id_facture).total :
			if  facture.status == 'Ouvert' or facture.status == 'Paye' or facture.status == 'Partiellement payee' :
				Facture.objects.filter(id =id_facture).update(status = "Ouvert")
			else :
				Facture.objects.filter(id =id_facture).update(status = "BROUILLON")
		elif montant_reste_fact == 0 :
			Facture.objects.filter(id = id_facture).update(status = "Paye")
		elif montant_reste_fact < Facture.objects.get(id = id_facture).total :
			Facture.objects.filter(id =id_facture).update(status = "Partiellement payee")
		

		if facture.commande :
				list_facture = Facture.objects.filter(commande = facture.commande)
				artclecom = ArticleCommandee.objects.filter(commande= facture.commande)
				commande = Commande.objects.get(id = facture.commande.id)
				reste_facture = 0
				montant_fact = 0
				qantite_reste = 0
				qantite_totaly = 0

				if list_facture :
					for fa in list_facture :
						reste_facture  = fa.reste + reste_facture
						montant_fact = fa.total +  montant_fact
				
				for a in artclecom : 
					qantite_reste = qantite_reste + a.qantite_reste
					qantite_totaly  = qantite_totaly + a.qantite_total
				
				if qantite_reste == qantite_totaly  :
					Commande.objects.filter(id = commande.id ).update(facturee = 'Non facture')
					Commande.objects.filter(id = commande.id).update(status = 'Emise')
				elif qantite_reste == 0 :
					 Commande.objects.filter(id = commande.id).update(facturee = 'facturee')
					 Commande.objects.filter(id = commande.id).update(status = 'FERME')
				elif qantite_reste < qantite_totaly :
					 Commande.objects.filter(id = commande.id).update(facturee = 'Partiellement facturee')
					 Commande.objects.filter(id = commande.id).update(status = 'Emise')
				
				if reste_facture == montant_fact :
						Commande.objects.filter(id = commande.id).update(paiement = 'Impaye')
				elif reste_facture == 0 :
					 if Commande.objects.get(id = commande.id).facturee == 'facturee' :
					 	Commande.objects.filter(id = commande.id).update(paiement = 'Paye')
					 else :
					 	Commande.objects.filter(id =commande.id).update(paiement ='Partiellement payee')	 	
				elif reste_facture < montant_fact :
					 Commande.objects.filter(id = commande.id).update(paiement = 'Partiellement payee')
							
		messages.info(request , 'facture a été  bien modifier')	
		
	
	return redirect('liste_facture_fournisseur')






@login_required(login_url="/login/")
def supprimer_facture_fournisseur(request):

	if request.method == "POST":
		id_facture = request.POST.get('id_facture')
		facture = Facture.objects.get(id = id_facture)
		articlescommandeefactures = Articlescommandeefactures.objects.filter(facture = facture)

		if facture.status == 'BROUILLON' or facture.status == 'Ouvert' :
				if facture.status == 'Ouvert' :		
					for i in range(len(articlescommandeefactures)) :
						if articlescommandeefactures[i].articleCommandee :
							articlecommandee = ArticleCommandee.objects.get(id = articlescommandeefactures[i].articleCommandee.id)
							qntite_new_reste = articlecommandee.qantite_reste + articlescommandeefactures[i].qantite
							mantant_new_reste = articlecommandee.montant_reste + articlescommandeefactures[i].montant
							qantitefacture = articlecommandee.facturee - articlescommandeefactures[i].qantite

							ArticleCommandee.objects.filter(id = articlecommandee.id).update(montant_reste = mantant_new_reste)
							ArticleCommandee.objects.filter(id = articlecommandee.id).update(qantite_reste = qntite_new_reste)
							ArticleCommandee.objects.filter(id = articlecommandee.id).update(facturee = qantitefacture)
							
							id_art = articlescommandeefactures[i].articleCommandee.article.id
							art = Article.objects.get(id = id_art) 
							new_stock_comptable_disponible_a_la_vente = art.stock_comptable_disponible_a_la_vente -  articlescommandeefactures[i].qantite
							new_stock_comptable_disponible = art.stock_comptable_disponible - articlescommandeefactures[i].qantite
							new_quantitee_non_declarer_comme_lot = art.quantitee_non_declarer_comme_lot - articlescommandeefactures[i].qantite
							Article.objects.filter(id = art.id).update(stock_comptable_disponible_a_la_vente = new_stock_comptable_disponible_a_la_vente)
							Article.objects.filter(id = art.id).update(stock_comptable_disponible = new_stock_comptable_disponible)
							Article.objects.filter(id = art.id).update(quantitee_non_declarer_comme_lot = new_quantitee_non_declarer_comme_lot)
								
		
						else : 
							id_art = articlescommandeefactures[i].article.id
							artic = Article.objects.get(id = id_art)
							new_stock_comptable_disponible_a_la_vente = artic.stock_comptable_disponible_a_la_vente - articlecommandeefacture[i].qantite
							new_stock_comptable_disponible = artic.stock_comptable_disponible - articlecommandeefacture[i].qantite
							new_stock_physique_disponible = artic.stock_physique_disponible - articlecommandeefacture[i].qantite
							new_stock_physique_disponible_a_la_vente = artic.stock_physique_disponible_a_la_vente - articlecommandeefacture[i].qantite
							new_quantitee_non_declarer_comme_lot = artic.quantitee_non_declarer_comme_lot - articlecommandeefacture[i].qantite


							Article.objects.filter(id = artic.id).update(stock_comptable_disponible_a_la_vente = new_stock_comptable_disponible_a_la_vente)
							Article.objects.filter(id = artic.id).update(stock_comptable_disponible = new_stock_comptable_disponible)
							Article.objects.filter(id = artic.id).update(quantitee_non_declarer_comme_lot = new_quantitee_non_declarer_comme_lot)
							Article.objects.filter(id = artic.id).update(stock_physique_disponible = new_stock_physique_disponible)
							Article.objects.filter(id = artic.id).update(stock_physique_disponible_a_la_vente = new_stock_physique_disponible_a_la_vente)
				
				else :
					for i in range(len(articlescommandeefactures)) :
						if articlescommandeefactures[i].articleCommandee :
							articlecommandee = ArticleCommandee.objects.get(id = articlescommandeefactures[i].articleCommandee.id)
							qntite_new_reste = articlecommandee.qantite_reste + articlescommandeefactures[i].qantite
							mantant_new_reste = articlecommandee.montant_reste + articlescommandeefactures[i].montant
							qantitefacture = articlecommandee.facturee - articlescommandeefactures[i].qantite

							ArticleCommandee.objects.filter(id = articlecommandee.id).update(montant_reste = mantant_new_reste)
							ArticleCommandee.objects.filter(id = articlecommandee.id).update(qantite_reste = qntite_new_reste)
							ArticleCommandee.objects.filter(id = articlecommandee.id).update(facturee = qantitefacture)

		
				if  facture.commande :
					commande = Commande.objects.get(id = facture.commande.id)
					list_facture = Facture.objects.filter(commande = commande)
					artclecom = ArticleCommandee.objects.filter(commande=commande)
					reste_facture = 0
					montant_fact = 0
					qantite_reste = 0
					qantite_totaly = 0

					if list_facture :
						for fa in list_facture :
							reste_facture  = fa.reste + reste_facture
							montant_fact = fa.total +  montant_fact
					
					for a in artclecom : 
						qantite_reste = qantite_reste + a.qantite_reste
						qantite_totaly  = qantite_totaly + a.qantite_total
					
					if qantite_reste == qantite_totaly  :
						Commande.objects.filter(id = commande.id ).update(facturee = 'Non facture')
						Commande.objects.filter(id = commande.id).update(status = 'Emise')
					elif qantite_reste == 0 :
						 Commande.objects.filter(id = commande.id).update(facturee = 'facturee')
						 Commande.objects.filter(id = commande.id).update(status = 'FERME')
					elif qantite_reste < qantite_totaly :
						 Commande.objects.filter(id = commande.id).update(facturee = 'Partiellement facturee')
						 Commande.objects.filter(id = commande.id).update(status = 'Emise')
					
					if reste_facture == montant_fact :
							Commande.objects.filter(id = commande.id).update(paiement = 'Impaye')
					elif reste_facture == 0 :
						 if Commande.objects.get(id = commande.id).facturee == 'facturee' :
						 	Commande.objects.filter(id = commande.id).update(paiement = 'Paye')
						 else :
						 	Commande.objects.filter(id =commande.id).update(paiement ='Partiellement payee')	 	
					elif reste_facture < montant_fact :
						 Commande.objects.filter(id = commande.id).update(paiement = 'Partiellement payee')
				
				facture.delete()
				messages.info(request , 'facture bien supprimé')			
		else :
			messages.info(request, 'Ce contact ne peut pas être supprimé car il est associé à des transactions ou des documents')

	return redirect('liste_facture_fournisseur')	
@login_required(login_url="/login/")
def getNumFacture(request):

	if request.is_ajax and request.method == "GET":

		id_facture = request.GET.get("id_facture", None)
		if Facture.objects.get(id = id_facture).client :
			numf = Facture.objects.all().exclude(id = id_facture).exclude(num_facture = 0).exclude(client =None).order_by('num_facture').reverse().first()
		else :
			numf = Facture.objects.all().exclude(id = id_facture).exclude(num_facture = 0).exclude(fournisseur =None).order_by('created_at').reverse().first()
		if numf  :
			num = '00'+ str(int(numf.num_facture) + 1)
		else :
			num  = '001'
		print('numf',num)

		new_liste = {}  
		lisd = {'id_facture' : num}
		new_liste[0] = lisd

		data= json.dumps(new_liste)
		return JsonResponse({"data":data}, status = 200)
	return JsonResponse({}, status = 400)	
