from django.shortcuts import render ,redirect
from clients.models import Client
from retours.models import Retour
import decimal 
from detailsretour.models import DetailRetour 
from facturesdavoir.models import Facture_d_avoir
from detailretourfactures.models import DetailRetourFacture
from django.contrib import messages
from io import BytesIO
from django.http import HttpResponse
from django.template.loader import get_template
from django.views import View
from xhtml2pdf import pisa
from remboursements.models import Remboursement
from django.contrib.auth.decorators import login_required
from articles.models import Article
from lots.models import Lot
from django.contrib import messages
import decimal
from django.urls import reverse
from urllib.parse import urlencode
from articles.models import Article
from datetime import date
from django.contrib.auth.models import User
# Create your views here.

def render_to_pdf(template_src, context_dict={}):
	template = get_template(template_src)
	html  = template.render(context_dict)
	result = BytesIO()
	print("result" , result)
	pdf = pisa.pisaDocument(BytesIO(html.encode("cp1252")), result)
	if not pdf.err:
		return HttpResponse(result.getvalue(), content_type='application/pdf')
	return None

class ViewPDF(View):
	def get(self, request, *args, **kwargs):
		id_facture = request.GET.get('id_facture')
		print('id ',id_facture)
		data = {
			"facture": Facture_d_avoir.objects.get(id = id_facture),
			"detail_retours_facture": DetailRetourFacture.objects.filter(facture_avoir_id = id_facture),
		}
		pdf = render_to_pdf('essai.html', data)
		return HttpResponse(pdf, content_type='application/pdf')
@login_required(login_url="/login/")
def formulaire_ajouter_facture_avoir(request):
	context = {}
	if request.method == "POST":
		id_retour = request.POST.get('id_retour')

	

	context['client'] = Retour.objects.get(id = id_retour).commande.client
	context['liste_agences'] = Agence.objects.all().values()
	context['liste_entrepots'] = Entrepot.objects.all()
	context['detail_retours'] = DetailRetour.objects.filter(retour_id = id_retour)
	context['id_retour'] = id_retour
	context['sous_total'] = Retour.objects.get(id = id_retour).total

	return render(request, 'ajouter-facture-avoir.html', context)

@login_required(login_url="/login/")
def ajouter_facture_avoir(request):
	context = {}
	if request.method == "POST":
		id_retour = request.POST.get('id_retour')
		print("id_retour", id_retour)
		id_client = request.POST.get('id_client')
		
		numero_facture_avoir = request.POST.get('numero_facture_avoir')
		date_facture_avoir = request.POST.get('date_facture_avoir')
		id_detail_retour = request.POST.getlist('detail_retour[]')
		taux_options = request.POST.getlist('taux_options[]')
		remise_options = request.POST.getlist('remise_options[]')
		taxe_options = request.POST.getlist('taxe_options[]')
		montant_options = request.POST.getlist('montant_options[]')
		sous_total = request.POST.get('sous_total')
		frais_expedition = request.POST.get('frais_expedition')
		ajustement = request.POST.get('ajustement')
		total = request.POST.get('total')
		condition_generales = request.POST.get('condition_generales')
		info_client = request.POST.get('info_client')
		userid = request.POST.get('user')
		user = User.objects.get(id = userid)
		if request.POST.get('entrepot') :
			id_entrepot = request.POST.get('entrepot')
		else :
			id_entrepot = None


	facture_obj = Facture_d_avoir(retour_id = id_retour,client_id = id_client
	, date_facture_avoir = date_facture_avoir, entrepot_id = id_entrepot, statut ="Brouillon", frai_expedition =frais_expedition
	, ajustement = ajustement, sous_total = sous_total, total = total,condition_general = condition_generales, information_client = info_client   ,reste = total ,user = user)

	facture_obj.save()
	for i in range(len(id_detail_retour)):
		detail_retour_objet = DetailRetour.objects.get(id = id_detail_retour[i] )
		objet_detail_retour_facturee = DetailRetourFacture(detail_retour_id = id_detail_retour[i], facture_avoir = facture_obj,quantitee = detail_retour_objet.quantitee_recu, taux = taux_options[i], taxe = taxe_options[i], montant = montant_options[i],
			remise = remise_options[i])
		objet_detail_retour_facturee.save()
	messages.success(request, "Facture d'avoir a été bien enregistré")

	return render(request, 'ajouter-facture-avoir.html', context)

@login_required(login_url="/login/")
def liste_facture_avoir(request):
	context = {}
	context['listes_facture_avoir'] = Facture_d_avoir.objects.all().order_by('created_at').reverse()

	return render(request, 'liste-facture-avoir.html', context)


@login_required(login_url="/login/")
def detail_facture_avoir(request):
	context = {}
	if request.method == "POST":
		id_facture_davoir = request.POST.get('id_facture_davoir')
	else : 
		id_facture_davoir = request.GET.get('000')	
	context['detail_retours_facture'] = DetailRetourFacture.objects.filter(facture_avoir_id = id_facture_davoir)
	context['facture'] = Facture_d_avoir.objects.get(id = id_facture_davoir)
	remboursements = Remboursement.objects.filter(facture_d_avoir_id = id_facture_davoir)
	total_m = 0
	if remboursements :
		for r in remboursements :
			total_m = total_m + r.montant

	context['remboursements'] = remboursements
	context['total_m'] = total_m
	if Facture_d_avoir.objects.get(id = id_facture_davoir).statut == 'Brouillon':
		numf = Facture_d_avoir.objects.all().exclude(id = id_facture_davoir).exclude(num_facture_avoir = 0).order_by('date_facture_avoir').reverse().first()
		if numf  :
			context['num_facture_avoir']  = '00'+ str(int(numf.num_facture_avoir) + 1)
		else :
			context['num_facture_avoir']   = '001'
	context['now'] = date.today()
	return render(request, 'detail-facture-avoir.html', context)


class DownloadPDF(View):
	def get(self, request,*args,**kwargs):
		id_facture = request.GET.get('id_facture')
		print('id ',id_facture)
		data = {
			"facture": Facture_d_avoir.objects.get(id = id_facture),
			"detail_retours_facture": DetailRetourFacture.objects.filter(facture_avoir_id = id_facture),
		}
		pdf = render_to_pdf('essai.html',data)
		#filename = "Invoice_%s.pdf" %("12341231")
		content = "attachment; filename= test.pdf"
		response = HttpResponse(pdf,content_type = 'application/pdf')
		response['Content-Disposition'] = content
		return response
		
@login_required(login_url="/login/")	
def marquer_comme_ouvert(request):
	context = {}
	if request.method == "POST":
		id_facture = request.POST.get('id_facture')
		num_facture_avoir = request.POST.get('num_facture_avoir')

		facture = Facture_d_avoir.objects.get(id = id_facture)

		if facture.statut == 'Brouillon' :
			Facture_d_avoir.objects.filter(id = id_facture).update(statut = "Ouvert")
			Facture_d_avoir.objects.filter(id = id_facture).update(num_facture_avoir = num_facture_avoir)
			detailRetourFacture = DetailRetourFacture.objects.filter(facture_avoir=facture)
			for i in range(len(detailRetourFacture)):
				if detailRetourFacture[i].detail_retour :
					article = detailRetourFacture[i].detail_retour.article_commandee.article.id
					lot = detailRetourFacture[i].detail_retour.article_commandee.lot.id
				else :
					article = detailRetourFacture[i].article.id
					lot = detailRetourFacture[i].lot.id

				stock_comptable_disponible_ancien = Article.objects.get(id = article).stock_comptable_disponible
				stock_physique_comptable_a_la_vente_ancien = Article.objects.get(id = article).stock_comptable_disponible_a_la_vente
				Article.objects.filter(id = article).update(stock_comptable_disponible = stock_comptable_disponible_ancien + detailRetourFacture[i].quantitee)
				Article.objects.filter(id = article).update(stock_comptable_disponible_a_la_vente = stock_physique_comptable_a_la_vente_ancien + detailRetourFacture[i].quantitee )
				quantitee_ancien = Lot.objects.get(id = lot).quantitee
				Lot.objects.filter(id = lot).update(quantitee = quantitee_ancien + detailRetourFacture[i].quantitee)
				if detailRetourFacture[i].article :
					stock_physique_disponible_ancien = Article.objects.get(id = article).stock_physique_disponible
					stock_physique_disponible_a_la_vente_ancien = Article.objects.get(id = article).stock_physique_disponible_a_la_vente
					Article.objects.filter(id = article).update(stock_physique_disponible = stock_physique_disponible_ancien + detailRetourFacture[i].quantitee)
					Article.objects.filter(id = article).update(stock_physique_disponible_a_la_vente = stock_physique_disponible_a_la_vente_ancien + detailRetourFacture[i].quantitee )


			messages.success(request, 'facture a été marque comme ouvert')
		else:
			messages.info(request, 'facture a été deja marque comme ouvert')
		base_url = reverse('detail_facture_avoir')  # 1 /products/
		query_string =  urlencode({'000': id_facture})  # 2 category=42
		url = '{}?{}'.format(base_url, query_string)  # 3 /products/?category=42
	return redirect(url)


login_required(login_url="/login/")
def supprimer_facturedavoir(request):
	if request.method == "POST":
		id_facture = request.POST.get('id_facture')
		facture = Facture_d_avoir.objects.get(id = id_facture)
		detailRetourFacture = DetailRetourFacture.objects.filter(facture_avoir=facture)
		if facture.statut == 'Brouillon' or facture.statut == 'Ouvert' :
			if facture.retour :
				Retour.objects.filter(id = facture.retour.id).update(staut_remboursement ='')
			if facture.statut == 'Ouvert' :	
				for i in range(len(detailRetourFacture)):
					if detailRetourFacture[i].detail_retour :
						detail_retour = detailRetourFacture[i].detail_retour.quantitee_recu
						article = detailRetourFacture[i].detail_retour.article_commandee.article.id
						lot = detailRetourFacture[i].detail_retour.article_commandee.lot.id
					else : 
						article = detailRetourFacture[i].article.id
						lot = detailRetourFacture[i].lot.id

					stock_comptable_disponible_ancien = Article.objects.get(id = article).stock_comptable_disponible
					stock_physique_comptable_a_la_vente_ancien = Article.objects.get(id = article).stock_comptable_disponible_a_la_vente
					Article.objects.filter(id = article).update(stock_comptable_disponible = stock_comptable_disponible_ancien - detailRetourFacture[i].quantitee)
					Article.objects.filter(id = article).update(stock_comptable_disponible_a_la_vente = stock_physique_comptable_a_la_vente_ancien - detailRetourFacture[i].quantitee )
					quantitee_ancien = Lot.objects.get(id = lot).quantitee
					Lot.objects.filter(id = lot).update(quantitee = quantitee_ancien - detailRetourFacture[i].quantitee)
					if detailRetourFacture[i].article :
						stock_physique_disponible_ancien = Article.objects.get(id = article).stock_physique_disponible
						stock_physique_disponible_a_la_vente_ancien = Article.objects.get(id = article).stock_physique_disponible_a_la_vente
						Article.objects.filter(id = article).update(stock_physique_disponible = stock_physique_disponible_ancien - detailRetourFacture[i].quantitee)
						Article.objects.filter(id = article).update(stock_physique_disponible_a_la_vente = stock_physique_disponible_a_la_vente_ancien - detailRetourFacture[i].quantitee )

			facture.delete()
			messages.info(request , 'facture bien supprimé')
		else :
			messages.info(request, 'Ce contact ne peut pas être supprimé car il est associé à des transactions ou des documents')
	return redirect('liste_facture_avoir')	

@login_required(login_url="/login/")
def formulaire_ajouter_facture_avoir_nouveau(request):
	context = {}

	context['liste_clients'] = Client.objects.filter(status ='actif')
	context['liste_agences'] = Agence.objects.all().values()
	context['liste_entrepots'] = Entrepot.objects.all()

	liste_articles = []
	artilces = Article.objects.all().exclude(quota = True)
	for i in artilces :
		if Lot.objects.all().filter(article = i).exists():
			liste_articles.append(i)

	context['liste_articles'] = liste_articles
	context['liste_conditionsPaiement'] = ConditionPaiement.objects.all().values()
	context['liste_villes'] = Ville.objects.all().values()

	id_f = Facture_d_avoir.objects.all().order_by('created_at').reverse().first()
	if id_f  :
		context['num_facture'] = '00'+ str(id_f.id)
	return render(request, 'ajouter-facture-avoir-nouveau.html', context)
	
@login_required(login_url="/login/")
def ajouter_facture_avoir_nouveau(request):
	context = {}
	if request.method == "POST":
		id_client = request.POST.get('id_client')
		id_entrepot = request.POST.get('entrepot')
		numero_facture_avoir = request.POST.get('numero_facture_avoir')
		date_facture_avoir = request.POST.get('date_facture_avoir')
		article_options = request.POST.getlist('article_options[]')
		lots_options= request.POST.getlist('lots_options[]')
		qantite_options = request.POST.getlist('qantite_options[]')
		taux_options = request.POST.getlist('taux_options[]')
		remise_options = request.POST.getlist('remise_options[]')
		taxe_options = request.POST.getlist('taxe_options[]')
		montant_options = request.POST.getlist('montant_options[]')
		sous_total = request.POST.get('sous_total')
		frais_expedition = request.POST.get('frais_expedition')
		ajustement = request.POST.get('ajustement')
		total = request.POST.get('total')
		condition_generales = request.POST.get('condition_generales')
		info_client = request.POST.get('info_client')
		userid = request.POST.get('user')
		user = User.objects.get(id = userid)


	facture_obj = Facture_d_avoir(client_id = id_client, date_facture_avoir = date_facture_avoir, entrepot_id = id_entrepot, statut ="Brouillon", frai_expedition =frais_expedition
	, ajustement = ajustement, sous_total = sous_total, total = total,condition_general = condition_generales, information_client = info_client   ,reste = total ,user = user)
	facture_obj.save()

	for i in range(len(qantite_options)):
		lot_id = lots_options[i].split()[0]
		lot_obj = Lot.objects.get(id=lot_id)
		article_id = article_options[i].split()[0]
		articel_fact = Article.objects.get(id = article_id)

		objet_detail_retour_facturee = DetailRetourFacture(facture_avoir = facture_obj,quantitee = qantite_options[i], taux = taux_options[i], taxe = taxe_options[i], montant = montant_options[i],
			remise = remise_options[i] ,article = articel_fact  , lot =lot_obj)
		objet_detail_retour_facturee.save()
	
	messages.success(request, "Facture d'avoir a été bien enregistré")
	return redirect('liste_facture_avoir')	