from django.db import models
from retours.models import Retour
from fournisseurs.models import Fournisseur
from decimal import Decimal
from django.core.validators import MinValueValidator
from django.contrib.auth.models import User

# Create your models here.
class Facture_d_avoir_fournisseur(models.Model):
	fournisseur = models.ForeignKey(Fournisseur, on_delete=models.SET_NULL, null=True, blank=True)
	num_facture = models.CharField(max_length=32, null=True, blank=True, unique = True)
	date = models.DateField(null=True, blank=True)
	
	statut = models.CharField(max_length = 59,blank=True , null=True)
	total = models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True)
	sous_total = models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True)
	solde = models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True,default=0)
	reste = models.DecimalField(max_digits=19, decimal_places=2 , blank=True , null=True,default=0)
	note = models.TextField(blank=True, null=True)
	remise = models.DecimalField(decimal_places=2, max_digits=19, blank=True, default=0, validators=[MinValueValidator(Decimal('0.00'))])
	created_at = models.DateTimeField(auto_now_add=True)
	updated_at = models.DateTimeField(auto_now=True)
	user = models.ForeignKey(User, on_delete=models.SET_NULL , null=True, blank=True )




