from django.shortcuts import render,redirect
from facturesdavoir.models import Facture_d_avoir
from detailretourfactures.models import DetailRetourFacture
from django.contrib.auth.decorators import login_required
from remboursements.forms import RemboursementForm , form_validation_error
from remboursements.models import Remboursement
from retours.models import Retour
from django.contrib import messages
import decimal
from django.urls import reverse
from urllib.parse import urlencode
from factures.models import Facture
from facturesdavoirfournisseurs.models import Facture_d_avoir_fournisseur
from detailsfacturedavoirfournisseurs.models import DetailFactureAvoirFournisseur

# Create your views here.
@login_required(login_url="/login/")
def afficher_ajouter_remboursements(request):
	context = {}
	if request.method == "POST":
		id_facture = request.POST.get('id_facture')
		type_fact = request.POST.get('type')

	else :
		id_facture = request.GET.get('000')
	if type_fact == 'facturedavoir' :
		facture = Facture_d_avoir.objects.get(id = id_facture)
		paiements = Remboursement.objects.filter(facture_d_avoir = facture)
	else :
		facture = Facture_d_avoir_fournisseur.objects.get(id = id_facture)
		paiements = Remboursement.objects.filter(Facture_d_avoir_fournisseur = facture)


	context['type'] = type_fact
	context['facture'] = facture
	context['max'] = facture.reste 

	return render(request, 'ajouter-remboursement.html', context)

@login_required(login_url="/login/")
def ajouter_remboursements(request):
	context = {}
	if request.method == "POST":
		id_facture = request.POST.get('facture')
		type_facture = request.POST.get('type')

		if id_facture != '':  
			if type_facture == 'facturedavoir' :
				facture = Facture_d_avoir.objects.get(id = id_facture)
			else : 
				facture = Facture_d_avoir_fournisseur.objects.get(id = id_facture)

			montant_payee = request.POST.get('montant')
			montant_total = decimal.Decimal(montant_payee)

			form = RemboursementForm(request.POST or None)
			if form.is_valid():
					form.save()
					last_paiement = Remboursement.objects.last().id
					paiement = Remboursement.objects.get(id = last_paiement)
					facture_reste = facture.reste - montant_total
					if montant_total < facture.reste :
						if type_facture =='facturedavoir' :
							Facture_d_avoir.objects.filter(id = id_facture).update(reste = facture_reste)
							Facture_d_avoir.objects.filter(id = id_facture).update(statut = "Partiellement Payee")
							if facture.retour : 
								Retour.objects.filter(id = facture.retour.id).update(staut_remboursement ='Partiellement remboursee')
						else :
							Facture_d_avoir_fournisseur.objects.filter(id = id_facture).update(reste = facture_reste)
							Facture_d_avoir_fournisseur.objects.filter(id = id_facture).update(statut = "partiellement payee")

					elif montant_total == facture.reste :
						if type_facture =='facturedavoir' :
							Facture_d_avoir.objects.filter(id = id_facture).update(reste = facture_reste)	
							if facture.retour :
								Retour.objects.filter(id = facture.retour.id).update(staut_remboursement ='rembourse')			
							Facture_d_avoir.objects.filter(id = id_facture).update(statut = "fermee")
						else :
							Facture_d_avoir_fournisseur.objects.filter(id = id_facture).update(reste = facture_reste)
							Facture_d_avoir_fournisseur.objects.filter(id = id_facture).update(statut = "fermee")

					if type_facture =='facturedavoir' :			
						Facture_d_avoir.objects.filter(id = id_facture).update(solde = facture.solde + decimal.Decimal(montant_payee))			
					else :
						Facture_d_avoir_fournisseur.objects.filter(id = id_facture).update(solde = facture.solde + decimal.Decimal(montant_payee))			

					messages.success(request, 'Remboursement a été bien ajouter')		
			else :
				messages.error(request, form_validation_error(form))	
		else :
			messages.error(request, 'no facature selected ')	
		if type_facture =='facturedavoir' :
			base_url = reverse('detail_facture_avoir')  # 1 /products/
		else :
			base_url = reverse('detail_facture_avoir_fournisseur')

		query_string =  urlencode({'000': id_facture})  # 2 category=42
		url = '{}?{}'.format(base_url, query_string)  # 3 /products/?category=42
	return redirect(url)
	
# @login_required(login_url="/login/")
# def afficher_remboursement(request):
#     context = {}
#     if request.method == "POST":
#     	id_paiement = request.POST.get('paiement')
#     	type_paiement = request.POST.get('type')
#     	if type_paiement == "paiement" :
#     		paiement = Paiement.objects.get(id = id_paiement)
#     		context['paiement'] = paiement

#     	else :
#     		paiement = GroupPaiement.objects.get(id = id_paiement)
#     		detailsgroupspaiement =Detailsgrouppaiement.objects.filter(grouppaiement = paiement) 
#     		context['paiement'] = paiement
#     		context['detailsgroupspaiement'] = detailsgroupspaiement

#     	context['type'] = type_paiement

#     return render(request, 'paiement-effectues.html', context)	



@login_required(login_url="/login/")
def supprimer_remboursements(request):
	if request.method == "POST":
			id_paiement = request.POST.get('remboursement')
			id_facture = request.POST.get('facture')
			type_facture = request.POST.get('type')
			paiement = Remboursement.objects.get(id = id_paiement)

			if type_facture == 'facturedavoir' :
				facture = Facture_d_avoir.objects.get(id = id_facture)
				if paiement.cheque :
					if paiement.cheque.status != 'invalid' :
						reste_facture = facture.reste + paiement.montant
						solde_facture= facture.solde - paiement.montant
						Facture_d_avoir.objects.filter(id = id_facture).update(reste = reste_facture)
						Facture_d_avoir.objects.filter(id = id_facture).update(solde = solde_facture)
						if  reste_facture == Facture_d_avoir.objects.get(id = id_facture).total :
							Facture_d_avoir.objects.filter(id = id_facture).update(statut = "Ouvert")
							if facture.retour :
								Retour.objects.filter(id = facture.retour.id).update(staut_remboursement ='')
						else :
							Facture_d_avoir.objects.filter(id = id_facture).update(statut = "Partiellement Payee")
							if facture.retour :
								Retour.objects.filter(id = facture.retour.id).update(staut_remboursement ='Partiellement remboursee')
					Cheque.objects.get(id = paiement.cheque.id).delete()
				else :		
					reste_facture = facture.reste + paiement.montant
					solde_facture= facture.solde - paiement.montant
					Facture_d_avoir.objects.filter(id = id_facture).update(reste = reste_facture)
					Facture_d_avoir.objects.filter(id = id_facture).update(solde = solde_facture)
					if  reste_facture == Facture_d_avoir.objects.get(id = id_facture).total :
						Facture_d_avoir.objects.filter(id = id_facture).update(statut = "Ouvert")
						if facture.retour :
							Retour.objects.filter(id = facture.retour.id).update(staut_remboursement ='')
					else :
						Facture_d_avoir.objects.filter(id = id_facture).update(statut = "Partiellement Payee")
						if facture.retour :
							Retour.objects.filter(id = facture.retour.id).update(staut_remboursement ='Partiellement remboursee')
			
			else :

					facture = Facture_d_avoir_fournisseur.objects.get(id = id_facture)
					reste_facture = facture.reste + paiement.montant
					solde_facture= facture.solde - paiement.montant
					Facture_d_avoir_fournisseur.objects.filter(id = id_facture).update(reste = reste_facture)
					Facture_d_avoir_fournisseur.objects.filter(id = id_facture).update(solde = solde_facture)
					if  reste_facture == Facture_d_avoir_fournisseur.objects.get(id = id_facture).total :
						Facture_d_avoir_fournisseur.objects.filter(id = id_facture).update(statut = "ouvert")
					else :
						Facture_d_avoir_fournisseur.objects.filter(id = id_facture).update(statut = "partiellement payee")
			
			paiement.delete()
			messages.success(request, 'Remboursement  bien supprimer')
			if type_facture == 'facturedavoir' :
				base_url = reverse('detail_facture_avoir')  # 1 /products/
			else :
				base_url = reverse('detail_facture_avoir_fournisseur')  # 1 /products/
			query_string =  urlencode({'000': id_facture})  # 2 category=42
			url = '{}?{}'.format(base_url, query_string)  # 3 /products/?category=42
	return redirect(url)


@login_required(login_url="/login/")
def afficher_modifier_remboursement(request):
    context = {}
    if request.method == "POST":
    	id_paiement = request.POST.get('remboursement')
    	paiement = Remboursement.objects.get(id = id_paiement)
    	context['paiement'] = paiement
    	context['type'] = request.POST.get('type')
    	if request.POST.get('type') == 'facturedavoir':
    		reste_paiement = paiement.facture_d_avoir.reste
    	else :
    		reste_paiement = paiement.Facture_d_avoir_fournisseur.reste

    	context['montant_max'] = reste_paiement + paiement.montant

    return render(request, 'modifier-remboursement.html', context)	

@login_required(login_url="/login/")
def valider_modifier_remboursement(request):
	context = {}
	if request.method == "POST":
		id_paiement = request.POST.get('paiement')
		type_facture = request.POST.get('type')
		date = request.POST.get('date_remboursement')
		montant = request.POST.get('montant')
		paiement = Remboursement.objects.get(id = id_paiement)
		montant_prec = paiement.montant
		if date :
			Remboursement.objects.filter(id = id_paiement).update(date_remboursement = date)

		Remboursement.objects.filter(id = id_paiement).update(montant = montant)
		if type_facture == 'facturedavoir' :
			facture = Facture_d_avoir.objects.get(id = paiement.facture_d_avoir.id)
		else :
			facture = Facture_d_avoir_fournisseur.objects.get(id = paiement.Facture_d_avoir_fournisseur.id)

		if type_facture == 'facturedavoir' :
				facture = Facture_d_avoir.objects.get(id = paiement.facture_d_avoir.id)
				if decimal.Decimal(montant) > montant_prec :
					diff = decimal.Decimal(montant) - montant_prec
					reste_facture = facture.reste - diff
					solde_facture = facture.solde + diff
				else :
					diff = montant_prec - decimal.Decimal(montant)
					reste_facture = facture.reste + diff
					solde_facture = facture.solde - diff
				
				Facture_d_avoir.objects.filter(id = facture.id).update(reste = reste_facture)
				Facture_d_avoir.objects.filter(id = facture.id).update(solde = solde_facture)

				if  reste_facture == Facture_d_avoir.objects.get(id = facture.id).total :
					Facture_d_avoir.objects.filter(id =facture.id).update(statut = "Ouvert")
					if facture.retour :
						Retour.objects.filter(id = facture.retour.id).update(staut_remboursement ='')
				elif reste_facture == 0 :
					Facture_d_avoir.objects.filter(id = facture.id).update(statut = "fermee")
					if facture.retour :
						Retour.objects.filter(id = facture.retour.id).update(staut_remboursement ='rembourse')
				elif reste_facture < Facture_d_avoir.objects.get(id = facture.id).total :
					Facture_d_avoir.objects.filter(id = facture.id).update(statut = "Partiellement Payee")
					if facture.retour :
						Retour.objects.filter(id = facture.retour.id).update(staut_remboursement ='Partiellement remboursee')

				base_url = reverse('detail_facture_avoir')
		else :
			facture = Facture_d_avoir_fournisseur.objects.get(id = paiement.Facture_d_avoir_fournisseur.id)
			if decimal.Decimal(montant) > montant_prec :
				diff = decimal.Decimal(montant) - montant_prec
				reste_facture = facture.reste - diff
				solde_facture = facture.solde + diff
			else :
				diff = montant_prec - decimal.Decimal(montant)
				reste_facture = facture.reste + diff
				solde_facture = facture.solde - diff
			
			Facture_d_avoir_fournisseur.objects.filter(id = facture.id).update(reste = reste_facture)
			Facture_d_avoir_fournisseur.objects.filter(id = facture.id).update(solde = solde_facture)

			if  reste_facture == Facture_d_avoir_fournisseur.objects.get(id = facture.id).total :
				Facture_d_avoir_fournisseur.objects.filter(id =facture.id).update(statut = "ouvert")
			elif reste_facture == 0 :
				Facture_d_avoir_fournisseur.objects.filter(id = facture.id).update(statut = "fermee")
			elif reste_facture < Facture_d_avoir_fournisseur.objects.get(id = facture.id).total :
				Facture_d_avoir_fournisseur.objects.filter(id = facture.id).update(statut = "partiellement payee")
			base_url = reverse('detail_facture_avoir_fournisseur')  # 1 /products/
		
		query_string =  urlencode({'000': facture.id})  # 2 category=42
		url = '{}?{}'.format(base_url, query_string)  # 3 /products/?category=42
		messages.success(request, 'Remboursement a ete  bien modifier')
	return redirect(url)


